#############################################################
# This file was automatically generated on 2020-05-13.      #
#                                                           #
# Saleae Bindings Version 2.0.1                             #
#                                                           #
# If you have a bugfix for this file and want to commit it, #
# please fix the bug in the generator. You can find a link  #
# to the generators git repository on tinkerforge.com       #
#############################################################


import json
import os
import sys
import struct
import re

# internal
def unpack_payload(data, form):
    ret = []

    for f in form.split(' '):
        o = f

        if '!' in f:
            if len(f) > 1:
                f = '{0}B'.format(int(math.ceil(int(f.replace('!', '')) / 8.0)))
            else:
                f = 'B'

        f = '<' + f
        length = struct.calcsize(f)
        x = struct.unpack(f, data[:length])

        if '!' in o:
            y = []

            if len(o) > 1:
                for i in range(int(o.replace('!', ''))):
                    y.append(x[i // 8] & (1 << (i % 8)) != 0)
            else:
                y.append(x[0] != 0)

            x = tuple(y)

        if 'c' in f:
            if sys.hexversion < 0x03000000:
                if len(x) > 1:
                    ret.append(x)
                else:
                    ret.append(x[0])
            else:
                if len(x) > 1:
                    ret.append(tuple(map(lambda item: chr(ord(item)), x)))
                else:
                    ret.append(chr(ord(x[0])))
        elif 's' in f:
            if sys.hexversion < 0x03000000:
                s = x[0]
            else:
                s = ''.join(map(chr, x[0]))

            i = s.find('\x00')

            if i >= 0:
                s = s[:i]

            ret.append(s)
        elif len(x) > 1:
            ret.append(x)
        else:
            ret.append(x[0])

        data = data[length:]

    if len(ret) == 1:
        return ret[0]
    else:
        return ret



device_infos = {
    11: {
    'device_identifier': 11,
    'name': 'DC Brick',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'h',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        3: {
            'function_id': 3,
            'name': 'Get Current Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        4: {
            'function_id': 4,
            'name': 'Set Acceleration',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Acceleration',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        6: {
            'function_id': 6,
            'name': 'Set PWM Frequency',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get PWM Frequency',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        8: {
            'function_id': 8,
            'name': 'Full Brake',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Stack Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        10: {
            'function_id': 10,
            'name': 'Get External Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        11: {
            'function_id': 11,
            'name': 'Get Current Consumption',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        12: {
            'function_id': 12,
            'name': 'Enable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Disable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Is Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        15: {
            'function_id': 15,
            'name': 'Set Minimum Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Minimum Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        17: {
            'function_id': 17,
            'name': 'Set Drive Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Drive Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        19: {
            'function_id': 19,
            'name': 'Set Current Velocity Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Get Current Velocity Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        21: {
            'function_id': 21,
            'name': 'Under Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        22: {
            'function_id': 22,
            'name': 'Emergency Shutdown',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        23: {
            'function_id': 23,
            'name': 'Velocity Reached',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        24: {
            'function_id': 24,
            'name': 'Current Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        231: {
            'function_id': 231,
            'name': 'Set SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        232: {
            'function_id': 232,
            'name': 'Get SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I',
        },
        233: {
            'function_id': 233,
            'name': 'Get Send Timeout Count',
            'elements': [
                {
                    'name': 'Communication Method',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Timeout Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Set SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c I',
            'out_struct_format': '',
        },
        235: {
            'function_id': 235,
            'name': 'Get SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I',
        },
        237: {
            'function_id': 237,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Count ACK Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I I I I',
        },
        238: {
            'function_id': 238,
            'name': 'Enable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        239: {
            'function_id': 239,
            'name': 'Disable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Is Status LED Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        241: {
            'function_id': 241,
            'name': 'Get Protocol1 Bricklet Name',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Protocol Version',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Name',
                    'type': 'string',
                    'cardinality': '40',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B 3B 40s',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        246: {
            'function_id': 246,
            'name': 'Write Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B 32B',
            'out_struct_format': '',
        },
        247: {
            'function_id': 247,
            'name': 'Read Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': '32B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
111: {
    'device_identifier': 111,
    'name': 'HAT Brick',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Sleep Mode',
            'elements': [
                {
                    'name': 'Power Off Delay',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Power Off Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Raspberry Pi Off',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Bricklets Off',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enable Sleep Indicator',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I I ! ! !',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Sleep Mode',
            'elements': [
                {
                    'name': 'Power Off Delay',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Power Off Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Raspberry Pi Off',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Bricklets Off',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enable Sleep Indicator',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I ! ! !',
        },
        3: {
            'function_id': 3,
            'name': 'Set Bricklet Power',
            'elements': [
                {
                    'name': 'Bricklet Power',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Bricklet Power',
            'elements': [
                {
                    'name': 'Bricklet Power',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        5: {
            'function_id': 5,
            'name': 'Get Voltages',
            'elements': [
                {
                    'name': 'Voltage USB',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Voltage DC',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Voltages Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Voltages Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        8: {
            'function_id': 8,
            'name': 'Voltages',
            'elements': [
                {
                    'name': 'Voltage USB',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Voltage DC',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
112: {
    'device_identifier': 112,
    'name': 'HAT Zero Brick',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get USB Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set USB Voltage Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get USB Voltage Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        4: {
            'function_id': 4,
            'name': 'USB Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
16: {
    'device_identifier': 16,
    'name': 'IMU Brick',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        2: {
            'function_id': 2,
            'name': 'Get Magnetic Field',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        3: {
            'function_id': 3,
            'name': 'Get Angular Velocity',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        4: {
            'function_id': 4,
            'name': 'Get All Data',
            'elements': [
                {
                    'name': 'Acc X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Acc Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Acc Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Mag X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Mag Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Mag Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Ang X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Ang Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Ang Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h h h h h h h h',
        },
        5: {
            'function_id': 5,
            'name': 'Get Orientation',
            'elements': [
                {
                    'name': 'Roll',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pitch',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Yaw',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        6: {
            'function_id': 6,
            'name': 'Get Quaternion',
            'elements': [
                {
                    'name': 'X',
                    'type': 'float',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'float',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'float',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'W',
                    'type': 'float',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'f f f f',
        },
        7: {
            'function_id': 7,
            'name': 'Get IMU Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        8: {
            'function_id': 8,
            'name': 'Leds On',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Leds Off',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Are Leds On',
            'elements': [
                {
                    'name': 'Leds',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        11: {
            'function_id': 11,
            'name': 'Set Acceleration Range',
            'elements': [
                {
                    'name': 'Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Acceleration Range',
            'elements': [
                {
                    'name': 'Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        13: {
            'function_id': 13,
            'name': 'Set Magnetometer Range',
            'elements': [
                {
                    'name': 'Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Magnetometer Range',
            'elements': [
                {
                    'name': 'Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        15: {
            'function_id': 15,
            'name': 'Set Convergence Speed',
            'elements': [
                {
                    'name': 'Speed',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Convergence Speed',
            'elements': [
                {
                    'name': 'Speed',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        17: {
            'function_id': 17,
            'name': 'Set Calibration',
            'elements': [
                {
                    'name': 'Typ',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data',
                    'type': 'int16',
                    'cardinality': '10',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B 10h',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Calibration',
            'elements': [
                {
                    'name': 'Typ',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data',
                    'type': 'int16',
                    'cardinality': '10',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '10h',
        },
        19: {
            'function_id': 19,
            'name': 'Set Acceleration Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Get Acceleration Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        21: {
            'function_id': 21,
            'name': 'Set Magnetic Field Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        22: {
            'function_id': 22,
            'name': 'Get Magnetic Field Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        23: {
            'function_id': 23,
            'name': 'Set Angular Velocity Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        24: {
            'function_id': 24,
            'name': 'Get Angular Velocity Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        25: {
            'function_id': 25,
            'name': 'Set All Data Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        26: {
            'function_id': 26,
            'name': 'Get All Data Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        27: {
            'function_id': 27,
            'name': 'Set Orientation Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        28: {
            'function_id': 28,
            'name': 'Get Orientation Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        29: {
            'function_id': 29,
            'name': 'Set Quaternion Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        30: {
            'function_id': 30,
            'name': 'Get Quaternion Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        31: {
            'function_id': 31,
            'name': 'Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        32: {
            'function_id': 32,
            'name': 'Magnetic Field',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        33: {
            'function_id': 33,
            'name': 'Angular Velocity',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        34: {
            'function_id': 34,
            'name': 'All Data',
            'elements': [
                {
                    'name': 'Acc X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Acc Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Acc Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Mag X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Mag Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Mag Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Ang X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Ang Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Ang Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h h h h h h h h',
        },
        35: {
            'function_id': 35,
            'name': 'Orientation',
            'elements': [
                {
                    'name': 'Roll',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pitch',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Yaw',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        36: {
            'function_id': 36,
            'name': 'Quaternion',
            'elements': [
                {
                    'name': 'X',
                    'type': 'float',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'float',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'float',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'W',
                    'type': 'float',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'f f f f',
        },
        37: {
            'function_id': 37,
            'name': 'Orientation Calculation On',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        38: {
            'function_id': 38,
            'name': 'Orientation Calculation Off',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        39: {
            'function_id': 39,
            'name': 'Is Orientation Calculation On',
            'elements': [
                {
                    'name': 'Orientation Calculation On',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        231: {
            'function_id': 231,
            'name': 'Set SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        232: {
            'function_id': 232,
            'name': 'Get SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I',
        },
        233: {
            'function_id': 233,
            'name': 'Get Send Timeout Count',
            'elements': [
                {
                    'name': 'Communication Method',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Timeout Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Set SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c I',
            'out_struct_format': '',
        },
        235: {
            'function_id': 235,
            'name': 'Get SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I',
        },
        237: {
            'function_id': 237,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Count ACK Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I I I I',
        },
        238: {
            'function_id': 238,
            'name': 'Enable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        239: {
            'function_id': 239,
            'name': 'Disable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Is Status LED Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        241: {
            'function_id': 241,
            'name': 'Get Protocol1 Bricklet Name',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Protocol Version',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Name',
                    'type': 'string',
                    'cardinality': '40',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B 3B 40s',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        246: {
            'function_id': 246,
            'name': 'Write Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B 32B',
            'out_struct_format': '',
        },
        247: {
            'function_id': 247,
            'name': 'Read Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': '32B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
18: {
    'device_identifier': 18,
    'name': 'IMU Brick 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        2: {
            'function_id': 2,
            'name': 'Get Magnetic Field',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        3: {
            'function_id': 3,
            'name': 'Get Angular Velocity',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        4: {
            'function_id': 4,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'b',
        },
        5: {
            'function_id': 5,
            'name': 'Get Orientation',
            'elements': [
                {
                    'name': 'Heading',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Roll',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pitch',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        6: {
            'function_id': 6,
            'name': 'Get Linear Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        7: {
            'function_id': 7,
            'name': 'Get Gravity Vector',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        8: {
            'function_id': 8,
            'name': 'Get Quaternion',
            'elements': [
                {
                    'name': 'W',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h h',
        },
        9: {
            'function_id': 9,
            'name': 'Get All Data',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Magnetic Field',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Angular Velocity',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Euler Angle',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Quaternion',
                    'type': 'int16',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Linear Acceleration',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Gravity Vector',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Calibration Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '3h 3h 3h 3h 4h 3h 3h b B',
        },
        10: {
            'function_id': 10,
            'name': 'Leds On',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Leds Off',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Are Leds On',
            'elements': [
                {
                    'name': 'Leds',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        13: {
            'function_id': 13,
            'name': 'Save Calibration',
            'elements': [
                {
                    'name': 'Calibration Done',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        14: {
            'function_id': 14,
            'name': 'Set Acceleration Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Acceleration Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        16: {
            'function_id': 16,
            'name': 'Set Magnetic Field Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Get Magnetic Field Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        18: {
            'function_id': 18,
            'name': 'Set Angular Velocity Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        19: {
            'function_id': 19,
            'name': 'Get Angular Velocity Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        20: {
            'function_id': 20,
            'name': 'Set Temperature Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        21: {
            'function_id': 21,
            'name': 'Get Temperature Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        22: {
            'function_id': 22,
            'name': 'Set Orientation Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        23: {
            'function_id': 23,
            'name': 'Get Orientation Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        24: {
            'function_id': 24,
            'name': 'Set Linear Acceleration Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        25: {
            'function_id': 25,
            'name': 'Get Linear Acceleration Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        26: {
            'function_id': 26,
            'name': 'Set Gravity Vector Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        27: {
            'function_id': 27,
            'name': 'Get Gravity Vector Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        28: {
            'function_id': 28,
            'name': 'Set Quaternion Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        29: {
            'function_id': 29,
            'name': 'Get Quaternion Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        30: {
            'function_id': 30,
            'name': 'Set All Data Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        31: {
            'function_id': 31,
            'name': 'Get All Data Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        32: {
            'function_id': 32,
            'name': 'Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        33: {
            'function_id': 33,
            'name': 'Magnetic Field',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        34: {
            'function_id': 34,
            'name': 'Angular Velocity',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        35: {
            'function_id': 35,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'b',
        },
        36: {
            'function_id': 36,
            'name': 'Linear Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        37: {
            'function_id': 37,
            'name': 'Gravity Vector',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        38: {
            'function_id': 38,
            'name': 'Orientation',
            'elements': [
                {
                    'name': 'Heading',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Roll',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pitch',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        39: {
            'function_id': 39,
            'name': 'Quaternion',
            'elements': [
                {
                    'name': 'W',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h h',
        },
        40: {
            'function_id': 40,
            'name': 'All Data',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Magnetic Field',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Angular Velocity',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Euler Angle',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Quaternion',
                    'type': 'int16',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Linear Acceleration',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Gravity Vector',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Calibration Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '3h 3h 3h 3h 4h 3h 3h b B',
        },
        41: {
            'function_id': 41,
            'name': 'Set Sensor Configuration',
            'elements': [
                {
                    'name': 'Magnetometer Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Gyroscope Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Gyroscope Bandwidth',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Accelerometer Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Accelerometer Bandwidth',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B B',
            'out_struct_format': '',
        },
        42: {
            'function_id': 42,
            'name': 'Get Sensor Configuration',
            'elements': [
                {
                    'name': 'Magnetometer Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Gyroscope Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Gyroscope Bandwidth',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Accelerometer Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Accelerometer Bandwidth',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B B B',
        },
        43: {
            'function_id': 43,
            'name': 'Set Sensor Fusion Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        44: {
            'function_id': 44,
            'name': 'Get Sensor Fusion Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        231: {
            'function_id': 231,
            'name': 'Set SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        232: {
            'function_id': 232,
            'name': 'Get SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I',
        },
        233: {
            'function_id': 233,
            'name': 'Get Send Timeout Count',
            'elements': [
                {
                    'name': 'Communication Method',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Timeout Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Set SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c I',
            'out_struct_format': '',
        },
        235: {
            'function_id': 235,
            'name': 'Get SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I',
        },
        237: {
            'function_id': 237,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Count ACK Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I I I I',
        },
        238: {
            'function_id': 238,
            'name': 'Enable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        239: {
            'function_id': 239,
            'name': 'Disable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Is Status LED Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        241: {
            'function_id': 241,
            'name': 'Get Protocol1 Bricklet Name',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Protocol Version',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Name',
                    'type': 'string',
                    'cardinality': '40',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B 3B 40s',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        246: {
            'function_id': 246,
            'name': 'Write Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B 32B',
            'out_struct_format': '',
        },
        247: {
            'function_id': 247,
            'name': 'Read Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': '32B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
13: {
    'device_identifier': 13,
    'name': 'Master Brick',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Stack Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Stack Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Extension Type',
            'elements': [
                {
                    'name': 'Extension',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Exttype',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Extension Type',
            'elements': [
                {
                    'name': 'Extension',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Exttype',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Is Chibi Present',
            'elements': [
                {
                    'name': 'Present',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        6: {
            'function_id': 6,
            'name': 'Set Chibi Address',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Chibi Address',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        8: {
            'function_id': 8,
            'name': 'Set Chibi Master Address',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Chibi Master Address',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        10: {
            'function_id': 10,
            'name': 'Set Chibi Slave Address',
            'elements': [
                {
                    'name': 'Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Chibi Slave Address',
            'elements': [
                {
                    'name': 'Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        12: {
            'function_id': 12,
            'name': 'Get Chibi Signal Strength',
            'elements': [
                {
                    'name': 'Signal Strength',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        13: {
            'function_id': 13,
            'name': 'Get Chibi Error Log',
            'elements': [
                {
                    'name': 'Underrun',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'CRC Error',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'No Ack',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Overflow',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H',
        },
        14: {
            'function_id': 14,
            'name': 'Set Chibi Frequency',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Chibi Frequency',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        16: {
            'function_id': 16,
            'name': 'Set Chibi Channel',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Get Chibi Channel',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        18: {
            'function_id': 18,
            'name': 'Is RS485 Present',
            'elements': [
                {
                    'name': 'Present',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        19: {
            'function_id': 19,
            'name': 'Set RS485 Address',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Get RS485 Address',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        21: {
            'function_id': 21,
            'name': 'Set RS485 Slave Address',
            'elements': [
                {
                    'name': 'Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        22: {
            'function_id': 22,
            'name': 'Get RS485 Slave Address',
            'elements': [
                {
                    'name': 'Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        23: {
            'function_id': 23,
            'name': 'Get RS485 Error Log',
            'elements': [
                {
                    'name': 'CRC Error',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        24: {
            'function_id': 24,
            'name': 'Set RS485 Configuration',
            'elements': [
                {
                    'name': 'Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Parity',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stopbits',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I c B',
            'out_struct_format': '',
        },
        25: {
            'function_id': 25,
            'name': 'Get RS485 Configuration',
            'elements': [
                {
                    'name': 'Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Parity',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stopbits',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I c B',
        },
        26: {
            'function_id': 26,
            'name': 'Is Wifi Present',
            'elements': [
                {
                    'name': 'Present',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        27: {
            'function_id': 27,
            'name': 'Set Wifi Configuration',
            'elements': [
                {
                    'name': 'SSID',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'in'
                },
                {
                    'name': 'Connection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '32s B 4B 4B 4B H',
            'out_struct_format': '',
        },
        28: {
            'function_id': 28,
            'name': 'Get Wifi Configuration',
            'elements': [
                {
                    'name': 'SSID',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'out'
                },
                {
                    'name': 'Connection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '32s B 4B 4B 4B H',
        },
        29: {
            'function_id': 29,
            'name': 'Set Wifi Encryption',
            'elements': [
                {
                    'name': 'Encryption',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Key',
                    'type': 'string',
                    'cardinality': '50',
                    'direction': 'in'
                },
                {
                    'name': 'Key Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'EAP Options',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'CA Certificate Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Client Certificate Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Private Key Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B 50s B B H H H',
            'out_struct_format': '',
        },
        30: {
            'function_id': 30,
            'name': 'Get Wifi Encryption',
            'elements': [
                {
                    'name': 'Encryption',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Key',
                    'type': 'string',
                    'cardinality': '50',
                    'direction': 'out'
                },
                {
                    'name': 'Key Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'EAP Options',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'CA Certificate Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Client Certificate Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Private Key Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B 50s B B H H H',
        },
        31: {
            'function_id': 31,
            'name': 'Get Wifi Status',
            'elements': [
                {
                    'name': 'MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                },
                {
                    'name': 'BSSID',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                },
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'RSSI',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'RX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'TX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '6B 6B B h 4B 4B 4B I I B',
        },
        32: {
            'function_id': 32,
            'name': 'Refresh Wifi Status',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        33: {
            'function_id': 33,
            'name': 'Set Wifi Certificate',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'in'
                },
                {
                    'name': 'Data Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H 32B B',
            'out_struct_format': '',
        },
        34: {
            'function_id': 34,
            'name': 'Get Wifi Certificate',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'out'
                },
                {
                    'name': 'Data Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '32B B',
        },
        35: {
            'function_id': 35,
            'name': 'Set Wifi Power Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        36: {
            'function_id': 36,
            'name': 'Get Wifi Power Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        37: {
            'function_id': 37,
            'name': 'Get Wifi Buffer Info',
            'elements': [
                {
                    'name': 'Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Low Watermark',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Used',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I H H',
        },
        38: {
            'function_id': 38,
            'name': 'Set Wifi Regulatory Domain',
            'elements': [
                {
                    'name': 'Domain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        39: {
            'function_id': 39,
            'name': 'Get Wifi Regulatory Domain',
            'elements': [
                {
                    'name': 'Domain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        40: {
            'function_id': 40,
            'name': 'Get USB Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        41: {
            'function_id': 41,
            'name': 'Set Long Wifi Key',
            'elements': [
                {
                    'name': 'Key',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64s',
            'out_struct_format': '',
        },
        42: {
            'function_id': 42,
            'name': 'Get Long Wifi Key',
            'elements': [
                {
                    'name': 'Key',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64s',
        },
        43: {
            'function_id': 43,
            'name': 'Set Wifi Hostname',
            'elements': [
                {
                    'name': 'Hostname',
                    'type': 'string',
                    'cardinality': '16',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '16s',
            'out_struct_format': '',
        },
        44: {
            'function_id': 44,
            'name': 'Get Wifi Hostname',
            'elements': [
                {
                    'name': 'Hostname',
                    'type': 'string',
                    'cardinality': '16',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '16s',
        },
        45: {
            'function_id': 45,
            'name': 'Set Stack Current Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        46: {
            'function_id': 46,
            'name': 'Get Stack Current Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        47: {
            'function_id': 47,
            'name': 'Set Stack Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        48: {
            'function_id': 48,
            'name': 'Get Stack Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        49: {
            'function_id': 49,
            'name': 'Set USB Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        50: {
            'function_id': 50,
            'name': 'Get USB Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        51: {
            'function_id': 51,
            'name': 'Set Stack Current Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        52: {
            'function_id': 52,
            'name': 'Get Stack Current Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        53: {
            'function_id': 53,
            'name': 'Set Stack Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        54: {
            'function_id': 54,
            'name': 'Get Stack Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        55: {
            'function_id': 55,
            'name': 'Set USB Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        56: {
            'function_id': 56,
            'name': 'Get USB Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        57: {
            'function_id': 57,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        58: {
            'function_id': 58,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        59: {
            'function_id': 59,
            'name': 'Stack Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        60: {
            'function_id': 60,
            'name': 'Stack Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        61: {
            'function_id': 61,
            'name': 'USB Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        62: {
            'function_id': 62,
            'name': 'Stack Current Reached',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        63: {
            'function_id': 63,
            'name': 'Stack Voltage Reached',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        64: {
            'function_id': 64,
            'name': 'USB Voltage Reached',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        65: {
            'function_id': 65,
            'name': 'Is Ethernet Present',
            'elements': [
                {
                    'name': 'Present',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        66: {
            'function_id': 66,
            'name': 'Set Ethernet Configuration',
            'elements': [
                {
                    'name': 'Connection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B 4B 4B 4B H',
            'out_struct_format': '',
        },
        67: {
            'function_id': 67,
            'name': 'Get Ethernet Configuration',
            'elements': [
                {
                    'name': 'Connection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B 4B 4B 4B H',
        },
        68: {
            'function_id': 68,
            'name': 'Get Ethernet Status',
            'elements': [
                {
                    'name': 'MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'RX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'TX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hostname',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '6B 4B 4B 4B I I 32s',
        },
        69: {
            'function_id': 69,
            'name': 'Set Ethernet Hostname',
            'elements': [
                {
                    'name': 'Hostname',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '32s',
            'out_struct_format': '',
        },
        70: {
            'function_id': 70,
            'name': 'Set Ethernet MAC Address',
            'elements': [
                {
                    'name': 'MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '6B',
            'out_struct_format': '',
        },
        71: {
            'function_id': 71,
            'name': 'Set Ethernet Websocket Configuration',
            'elements': [
                {
                    'name': 'Sockets',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H',
            'out_struct_format': '',
        },
        72: {
            'function_id': 72,
            'name': 'Get Ethernet Websocket Configuration',
            'elements': [
                {
                    'name': 'Sockets',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B H',
        },
        73: {
            'function_id': 73,
            'name': 'Set Ethernet Authentication Secret',
            'elements': [
                {
                    'name': 'Secret',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64s',
            'out_struct_format': '',
        },
        74: {
            'function_id': 74,
            'name': 'Get Ethernet Authentication Secret',
            'elements': [
                {
                    'name': 'Secret',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64s',
        },
        75: {
            'function_id': 75,
            'name': 'Set Wifi Authentication Secret',
            'elements': [
                {
                    'name': 'Secret',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64s',
            'out_struct_format': '',
        },
        76: {
            'function_id': 76,
            'name': 'Get Wifi Authentication Secret',
            'elements': [
                {
                    'name': 'Secret',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64s',
        },
        77: {
            'function_id': 77,
            'name': 'Get Connection Type',
            'elements': [
                {
                    'name': 'Connection Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        78: {
            'function_id': 78,
            'name': 'Is Wifi2 Present',
            'elements': [
                {
                    'name': 'Present',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        79: {
            'function_id': 79,
            'name': 'Start Wifi2 Bootloader',
            'elements': [
                {
                    'name': 'Result',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'b',
        },
        80: {
            'function_id': 80,
            'name': 'Write Wifi2 Serial Port',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Result',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '60B B',
            'out_struct_format': 'b',
        },
        81: {
            'function_id': 81,
            'name': 'Read Wifi2 Serial Port',
            'elements': [
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'out'
                },
                {
                    'name': 'Result',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '60B B',
        },
        82: {
            'function_id': 82,
            'name': 'Set Wifi2 Authentication Secret',
            'elements': [
                {
                    'name': 'Secret',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64s',
            'out_struct_format': '',
        },
        83: {
            'function_id': 83,
            'name': 'Get Wifi2 Authentication Secret',
            'elements': [
                {
                    'name': 'Secret',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64s',
        },
        84: {
            'function_id': 84,
            'name': 'Set Wifi2 Configuration',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Websocket Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Website Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'PHY Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Sleep Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Website',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H H B B B',
            'out_struct_format': '',
        },
        85: {
            'function_id': 85,
            'name': 'Get Wifi2 Configuration',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Websocket Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Website Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'PHY Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Sleep Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Website',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H B B B',
        },
        86: {
            'function_id': 86,
            'name': 'Get Wifi2 Status',
            'elements': [
                {
                    'name': 'Client Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Client Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Client IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Client Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Client Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Client MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                },
                {
                    'name': 'Client RX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Client TX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Client RSSI',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'AP Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'AP IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'AP Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'AP Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'AP MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                },
                {
                    'name': 'AP RX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'AP TX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'AP Connected Count',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! B 4B 4B 4B 6B I I b ! 4B 4B 4B 6B I I B',
        },
        87: {
            'function_id': 87,
            'name': 'Set Wifi2 Client Configuration',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'SSID',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'in'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'in'
                },
                {
                    'name': 'BSSID',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! 32s 4B 4B 4B 6B 6B',
            'out_struct_format': '',
        },
        88: {
            'function_id': 88,
            'name': 'Get Wifi2 Client Configuration',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'SSID',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'out'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                },
                {
                    'name': 'BSSID',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! 32s 4B 4B 4B 6B 6B',
        },
        89: {
            'function_id': 89,
            'name': 'Set Wifi2 Client Hostname',
            'elements': [
                {
                    'name': 'Hostname',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '32s',
            'out_struct_format': '',
        },
        90: {
            'function_id': 90,
            'name': 'Get Wifi2 Client Hostname',
            'elements': [
                {
                    'name': 'Hostname',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '32s',
        },
        91: {
            'function_id': 91,
            'name': 'Set Wifi2 Client Password',
            'elements': [
                {
                    'name': 'Password',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64s',
            'out_struct_format': '',
        },
        92: {
            'function_id': 92,
            'name': 'Get Wifi2 Client Password',
            'elements': [
                {
                    'name': 'Password',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64s',
        },
        93: {
            'function_id': 93,
            'name': 'Set Wifi2 AP Configuration',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'SSID',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'in'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Encryption',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Hidden',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! 32s 4B 4B 4B B ! B 6B',
            'out_struct_format': '',
        },
        94: {
            'function_id': 94,
            'name': 'Get Wifi2 AP Configuration',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'SSID',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'out'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Encryption',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hidden',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! 32s 4B 4B 4B B ! B 6B',
        },
        95: {
            'function_id': 95,
            'name': 'Set Wifi2 AP Password',
            'elements': [
                {
                    'name': 'Password',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64s',
            'out_struct_format': '',
        },
        96: {
            'function_id': 96,
            'name': 'Get Wifi2 AP Password',
            'elements': [
                {
                    'name': 'Password',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64s',
        },
        97: {
            'function_id': 97,
            'name': 'Save Wifi2 Configuration',
            'elements': [
                {
                    'name': 'Result',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        98: {
            'function_id': 98,
            'name': 'Get Wifi2 Firmware Version',
            'elements': [
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '3B',
        },
        99: {
            'function_id': 99,
            'name': 'Enable Wifi2 Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        100: {
            'function_id': 100,
            'name': 'Disable Wifi2 Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        101: {
            'function_id': 101,
            'name': 'Is Wifi2 Status LED Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        102: {
            'function_id': 102,
            'name': 'Set Wifi2 Mesh Configuration',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Root IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Root Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Root Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Router BSSID',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'in'
                },
                {
                    'name': 'Group ID',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'in'
                },
                {
                    'name': 'Group SSID Prefix',
                    'type': 'string',
                    'cardinality': '16',
                    'direction': 'in'
                },
                {
                    'name': 'Gateway IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Gateway Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! 4B 4B 4B 6B 6B 16s 4B H',
            'out_struct_format': '',
        },
        103: {
            'function_id': 103,
            'name': 'Get Wifi2 Mesh Configuration',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Root IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Root Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Root Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Router BSSID',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                },
                {
                    'name': 'Group ID',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                },
                {
                    'name': 'Group SSID Prefix',
                    'type': 'string',
                    'cardinality': '16',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway Port',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! 4B 4B 4B 6B 6B 16s 4B H',
        },
        104: {
            'function_id': 104,
            'name': 'Set Wifi2 Mesh Router SSID',
            'elements': [
                {
                    'name': 'SSID',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '32s',
            'out_struct_format': '',
        },
        105: {
            'function_id': 105,
            'name': 'Get Wifi2 Mesh Router SSID',
            'elements': [
                {
                    'name': 'SSID',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '32s',
        },
        106: {
            'function_id': 106,
            'name': 'Set Wifi2 Mesh Router Password',
            'elements': [
                {
                    'name': 'Password',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64s',
            'out_struct_format': '',
        },
        107: {
            'function_id': 107,
            'name': 'Get Wifi2 Mesh Router Password',
            'elements': [
                {
                    'name': 'Password',
                    'type': 'string',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64s',
        },
        108: {
            'function_id': 108,
            'name': 'Get Wifi2 Mesh Common Status',
            'elements': [
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Root Node',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Root Candidate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Nodes',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'RX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'TX Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B ! ! H I I',
        },
        109: {
            'function_id': 109,
            'name': 'Get Wifi2 Mesh Client Status',
            'elements': [
                {
                    'name': 'Hostname',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'out'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '32s 4B 4B 4B 6B',
        },
        110: {
            'function_id': 110,
            'name': 'Get Wifi2 Mesh AP Status',
            'elements': [
                {
                    'name': 'SSID',
                    'type': 'string',
                    'cardinality': '32',
                    'direction': 'out'
                },
                {
                    'name': 'IP',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Subnet Mask',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Gateway',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'MAC Address',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '32s 4B 4B 4B 6B',
        },
        111: {
            'function_id': 111,
            'name': 'Set Bricklet XMC Flash Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Parameter1',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Parameter2',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '52',
                    'direction': 'in'
                },
                {
                    'name': 'Return Value',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Return Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'I I I 52B',
            'out_struct_format': 'I 60B',
        },
        112: {
            'function_id': 112,
            'name': 'Set Bricklet XMC Flash Data',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Return Data',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'I',
        },
        113: {
            'function_id': 113,
            'name': 'Set Bricklets Enabled',
            'elements': [
                {
                    'name': 'Bricklets Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        114: {
            'function_id': 114,
            'name': 'Get Bricklets Enabled',
            'elements': [
                {
                    'name': 'Bricklets Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        231: {
            'function_id': 231,
            'name': 'Set SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        232: {
            'function_id': 232,
            'name': 'Get SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I',
        },
        233: {
            'function_id': 233,
            'name': 'Get Send Timeout Count',
            'elements': [
                {
                    'name': 'Communication Method',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Timeout Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Set SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c I',
            'out_struct_format': '',
        },
        235: {
            'function_id': 235,
            'name': 'Get SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I',
        },
        237: {
            'function_id': 237,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Count ACK Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I I I I',
        },
        238: {
            'function_id': 238,
            'name': 'Enable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        239: {
            'function_id': 239,
            'name': 'Disable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Is Status LED Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        241: {
            'function_id': 241,
            'name': 'Get Protocol1 Bricklet Name',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Protocol Version',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Name',
                    'type': 'string',
                    'cardinality': '40',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B 3B 40s',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        246: {
            'function_id': 246,
            'name': 'Write Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B 32B',
            'out_struct_format': '',
        },
        247: {
            'function_id': 247,
            'name': 'Read Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': '32B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
17: {
    'device_identifier': 17,
    'name': 'RED Brick',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Create Session',
            'elements': [
                {
                    'name': 'Lifetime',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': 'B H',
        },
        2: {
            'function_id': 2,
            'name': 'Expire Session',
            'elements': [
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B',
        },
        3: {
            'function_id': 3,
            'name': 'Expire Session Unchecked',
            'elements': [
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Keep Session Alive',
            'elements': [
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Lifetime',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H I',
            'out_struct_format': 'B',
        },
        5: {
            'function_id': 5,
            'name': 'Release Object',
            'elements': [
                {
                    'name': 'Object Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B',
        },
        6: {
            'function_id': 6,
            'name': 'Release Object Unchecked',
            'elements': [
                {
                    'name': 'Object Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Allocate String',
            'elements': [
                {
                    'name': 'Length To Reserve',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Buffer',
                    'type': 'string',
                    'cardinality': '58',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'I 58s H',
            'out_struct_format': 'B H',
        },
        8: {
            'function_id': 8,
            'name': 'Truncate String',
            'elements': [
                {
                    'name': 'String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H I',
            'out_struct_format': 'B',
        },
        9: {
            'function_id': 9,
            'name': 'Get String Length',
            'elements': [
                {
                    'name': 'String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Length',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B I',
        },
        10: {
            'function_id': 10,
            'name': 'Set String Chunk',
            'elements': [
                {
                    'name': 'String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Buffer',
                    'type': 'string',
                    'cardinality': '58',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H I 58s',
            'out_struct_format': 'B',
        },
        11: {
            'function_id': 11,
            'name': 'Get String Chunk',
            'elements': [
                {
                    'name': 'String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Buffer',
                    'type': 'string',
                    'cardinality': '63',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H I',
            'out_struct_format': 'B 63s',
        },
        12: {
            'function_id': 12,
            'name': 'Allocate List',
            'elements': [
                {
                    'name': 'Length To Reserve',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H',
        },
        13: {
            'function_id': 13,
            'name': 'Get List Length',
            'elements': [
                {
                    'name': 'List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B H',
        },
        14: {
            'function_id': 14,
            'name': 'Get List Item',
            'elements': [
                {
                    'name': 'List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Item Object Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H H',
            'out_struct_format': 'B H B',
        },
        15: {
            'function_id': 15,
            'name': 'Append To List',
            'elements': [
                {
                    'name': 'List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Item Object Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B',
        },
        16: {
            'function_id': 16,
            'name': 'Remove From List',
            'elements': [
                {
                    'name': 'List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B',
        },
        17: {
            'function_id': 17,
            'name': 'Open File',
            'elements': [
                {
                    'name': 'Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Flags',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Permissions',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'GID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H I H I I H',
            'out_struct_format': 'B H',
        },
        18: {
            'function_id': 18,
            'name': 'Create Pipe',
            'elements': [
                {
                    'name': 'Flags',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'I Q H',
            'out_struct_format': 'B H',
        },
        19: {
            'function_id': 19,
            'name': 'Get File Info',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Flags',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Permissions',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'GID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Length',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Access Timestamp',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Modification Timestamp',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Status Change Timestamp',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B B H I H I I Q Q Q Q',
        },
        20: {
            'function_id': 20,
            'name': 'Read File',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length To Read',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Buffer',
                    'type': 'uint8',
                    'cardinality': '62',
                    'direction': 'out'
                },
                {
                    'name': 'Length Read',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H B',
            'out_struct_format': 'B 62B B',
        },
        21: {
            'function_id': 21,
            'name': 'Read File Async',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length To Read',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H Q',
            'out_struct_format': '',
        },
        22: {
            'function_id': 22,
            'name': 'Abort Async File Read',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B',
        },
        23: {
            'function_id': 23,
            'name': 'Write File',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Buffer',
                    'type': 'uint8',
                    'cardinality': '61',
                    'direction': 'in'
                },
                {
                    'name': 'Length To Write',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Length Written',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H 61B B',
            'out_struct_format': 'B B',
        },
        24: {
            'function_id': 24,
            'name': 'Write File Unchecked',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Buffer',
                    'type': 'uint8',
                    'cardinality': '61',
                    'direction': 'in'
                },
                {
                    'name': 'Length To Write',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H 61B B',
            'out_struct_format': '',
        },
        25: {
            'function_id': 25,
            'name': 'Write File Async',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Buffer',
                    'type': 'uint8',
                    'cardinality': '61',
                    'direction': 'in'
                },
                {
                    'name': 'Length To Write',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H 61B B',
            'out_struct_format': '',
        },
        26: {
            'function_id': 26,
            'name': 'Set File Position',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Origin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H q B',
            'out_struct_format': 'B Q',
        },
        27: {
            'function_id': 27,
            'name': 'Get File Position',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B Q',
        },
        28: {
            'function_id': 28,
            'name': 'Set File Events',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Events',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B',
        },
        29: {
            'function_id': 29,
            'name': 'Get File Events',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Events',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B H',
        },
        30: {
            'function_id': 30,
            'name': 'Async File Read',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Buffer',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'out'
                },
                {
                    'name': 'Length Read',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B 60B B',
        },
        31: {
            'function_id': 31,
            'name': 'Async File Write',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Length Written',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B B',
        },
        32: {
            'function_id': 32,
            'name': 'File Events Occurred',
            'elements': [
                {
                    'name': 'File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Events',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        33: {
            'function_id': 33,
            'name': 'Open Directory',
            'elements': [
                {
                    'name': 'Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Directory Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H',
        },
        34: {
            'function_id': 34,
            'name': 'Get Directory Name',
            'elements': [
                {
                    'name': 'Directory Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H',
        },
        35: {
            'function_id': 35,
            'name': 'Get Next Directory Entry',
            'elements': [
                {
                    'name': 'Directory Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H B',
        },
        36: {
            'function_id': 36,
            'name': 'Rewind Directory',
            'elements': [
                {
                    'name': 'Directory Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B',
        },
        37: {
            'function_id': 37,
            'name': 'Create Directory',
            'elements': [
                {
                    'name': 'Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Flags',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Permissions',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'GID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H I H I I',
            'out_struct_format': 'B',
        },
        38: {
            'function_id': 38,
            'name': 'Get Processes',
            'elements': [
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Processes List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B H',
        },
        39: {
            'function_id': 39,
            'name': 'Spawn Process',
            'elements': [
                {
                    'name': 'Executable String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Arguments List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Environment List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Working Directory String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'GID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stdin File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stdout File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stderr File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Process Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H H H I I H H H H',
            'out_struct_format': 'B H',
        },
        40: {
            'function_id': 40,
            'name': 'Kill Process',
            'elements': [
                {
                    'name': 'Process Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Signal',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H B',
            'out_struct_format': 'B',
        },
        41: {
            'function_id': 41,
            'name': 'Get Process Command',
            'elements': [
                {
                    'name': 'Process Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Executable String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Arguments List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Environment List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Working Directory String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H H H H',
        },
        42: {
            'function_id': 42,
            'name': 'Get Process Identity',
            'elements': [
                {
                    'name': 'Process Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'PID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'GID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B I I I',
        },
        43: {
            'function_id': 43,
            'name': 'Get Process Stdio',
            'elements': [
                {
                    'name': 'Process Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stdin File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stdout File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stderr File Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H H H',
        },
        44: {
            'function_id': 44,
            'name': 'Get Process State',
            'elements': [
                {
                    'name': 'Process Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Timestamp',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exit Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B B Q B',
        },
        45: {
            'function_id': 45,
            'name': 'Process State Changed',
            'elements': [
                {
                    'name': 'Process Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Timestamp',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exit Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B Q B',
        },
        46: {
            'function_id': 46,
            'name': 'Get Programs',
            'elements': [
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Programs List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B H',
        },
        47: {
            'function_id': 47,
            'name': 'Define Program',
            'elements': [
                {
                    'name': 'Identifier String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H',
        },
        48: {
            'function_id': 48,
            'name': 'Purge Program',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Cookie',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H I',
            'out_struct_format': 'B',
        },
        49: {
            'function_id': 49,
            'name': 'Get Program Identifier',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifier String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H',
        },
        50: {
            'function_id': 50,
            'name': 'Get Program Root Directory',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Root Directory String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H',
        },
        51: {
            'function_id': 51,
            'name': 'Set Program Command',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Executable String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Arguments List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Environment List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Working Directory String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H H H H',
            'out_struct_format': 'B',
        },
        52: {
            'function_id': 52,
            'name': 'Get Program Command',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Executable String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Arguments List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Environment List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Working Directory String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H H H H',
        },
        53: {
            'function_id': 53,
            'name': 'Set Program Stdio Redirection',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stdin Redirection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stdin File Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stdout Redirection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stdout File Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stderr Redirection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stderr File Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H B H B H B H',
            'out_struct_format': 'B',
        },
        54: {
            'function_id': 54,
            'name': 'Get Program Stdio Redirection',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stdin Redirection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stdin File Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stdout Redirection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stdout File Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stderr Redirection',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stderr File Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B B H B H B H',
        },
        55: {
            'function_id': 55,
            'name': 'Set Program Schedule',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Start Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Continue After Error',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Start Interval',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Start Fields String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H B ! I H',
            'out_struct_format': 'B',
        },
        56: {
            'function_id': 56,
            'name': 'Get Program Schedule',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Start Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Continue After Error',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Start Interval',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Start Fields String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B B ! I H',
        },
        57: {
            'function_id': 57,
            'name': 'Get Program Scheduler State',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Timestamp',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Message String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B B Q H',
        },
        58: {
            'function_id': 58,
            'name': 'Continue Program Schedule',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B',
        },
        59: {
            'function_id': 59,
            'name': 'Start Program',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'B',
        },
        60: {
            'function_id': 60,
            'name': 'Get Last Spawned Program Process',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Process Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Timestamp',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H Q',
        },
        61: {
            'function_id': 61,
            'name': 'Get Custom Program Option Names',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Names List Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B H',
        },
        62: {
            'function_id': 62,
            'name': 'Set Custom Program Option Value',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H H',
            'out_struct_format': 'B',
        },
        63: {
            'function_id': 63,
            'name': 'Get Custom Program Option Value',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Session Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H H',
            'out_struct_format': 'B H',
        },
        64: {
            'function_id': 64,
            'name': 'Remove Custom Program Option',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Name String Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'B',
        },
        65: {
            'function_id': 65,
            'name': 'Program Scheduler State Changed',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        66: {
            'function_id': 66,
            'name': 'Program Process Spawned',
            'elements': [
                {
                    'name': 'Program Id',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
14: {
    'device_identifier': 14,
    'name': 'Servo Brick',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Enable',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Disable',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Is Enabled',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '!',
        },
        4: {
            'function_id': 4,
            'name': 'Set Position',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B h',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Position',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'h',
        },
        6: {
            'function_id': 6,
            'name': 'Get Current Position',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'h',
        },
        7: {
            'function_id': 7,
            'name': 'Set Velocity',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Velocity',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H',
        },
        9: {
            'function_id': 9,
            'name': 'Get Current Velocity',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H',
        },
        10: {
            'function_id': 10,
            'name': 'Set Acceleration',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Acceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Acceleration',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Acceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H',
        },
        12: {
            'function_id': 12,
            'name': 'Set Output Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Output Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        14: {
            'function_id': 14,
            'name': 'Set Pulse Width',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H H',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Pulse Width',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H H',
        },
        16: {
            'function_id': 16,
            'name': 'Set Degree',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B h h',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Get Degree',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'h h',
        },
        18: {
            'function_id': 18,
            'name': 'Set Period',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H',
            'out_struct_format': '',
        },
        19: {
            'function_id': 19,
            'name': 'Get Period',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H',
        },
        20: {
            'function_id': 20,
            'name': 'Get Servo Current',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H',
        },
        21: {
            'function_id': 21,
            'name': 'Get Overall Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        22: {
            'function_id': 22,
            'name': 'Get Stack Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        23: {
            'function_id': 23,
            'name': 'Get External Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        24: {
            'function_id': 24,
            'name': 'Set Minimum Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        25: {
            'function_id': 25,
            'name': 'Get Minimum Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        26: {
            'function_id': 26,
            'name': 'Under Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        27: {
            'function_id': 27,
            'name': 'Position Reached',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B h',
        },
        28: {
            'function_id': 28,
            'name': 'Velocity Reached',
            'elements': [
                {
                    'name': 'Servo Num',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B h',
        },
        29: {
            'function_id': 29,
            'name': 'Enable Position Reached Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        30: {
            'function_id': 30,
            'name': 'Disable Position Reached Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        31: {
            'function_id': 31,
            'name': 'Is Position Reached Callback Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        32: {
            'function_id': 32,
            'name': 'Enable Velocity Reached Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        33: {
            'function_id': 33,
            'name': 'Disable Velocity Reached Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        34: {
            'function_id': 34,
            'name': 'Is Velocity Reached Callback Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        231: {
            'function_id': 231,
            'name': 'Set SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        232: {
            'function_id': 232,
            'name': 'Get SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I',
        },
        233: {
            'function_id': 233,
            'name': 'Get Send Timeout Count',
            'elements': [
                {
                    'name': 'Communication Method',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Timeout Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Set SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c I',
            'out_struct_format': '',
        },
        235: {
            'function_id': 235,
            'name': 'Get SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I',
        },
        237: {
            'function_id': 237,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Count ACK Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I I I I',
        },
        238: {
            'function_id': 238,
            'name': 'Enable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        239: {
            'function_id': 239,
            'name': 'Disable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Is Status LED Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        241: {
            'function_id': 241,
            'name': 'Get Protocol1 Bricklet Name',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Protocol Version',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Name',
                    'type': 'string',
                    'cardinality': '40',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B 3B 40s',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        246: {
            'function_id': 246,
            'name': 'Write Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B 32B',
            'out_struct_format': '',
        },
        247: {
            'function_id': 247,
            'name': 'Read Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': '32B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
19: {
    'device_identifier': 19,
    'name': 'Silent Stepper Brick',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Max Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Max Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Get Current Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        4: {
            'function_id': 4,
            'name': 'Set Speed Ramping',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Deacceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Speed Ramping',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Deacceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        6: {
            'function_id': 6,
            'name': 'Full Brake',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Set Current Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Current Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        9: {
            'function_id': 9,
            'name': 'Set Target Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Target Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        11: {
            'function_id': 11,
            'name': 'Set Steps',
            'elements': [
                {
                    'name': 'Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Steps',
            'elements': [
                {
                    'name': 'Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        13: {
            'function_id': 13,
            'name': 'Get Remaining Steps',
            'elements': [
                {
                    'name': 'Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        14: {
            'function_id': 14,
            'name': 'Set Step Configuration',
            'elements': [
                {
                    'name': 'Step Resolution',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Interpolation',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Step Configuration',
            'elements': [
                {
                    'name': 'Step Resolution',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Interpolation',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        16: {
            'function_id': 16,
            'name': 'Drive Forward',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Drive Backward',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Stop',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        19: {
            'function_id': 19,
            'name': 'Get Stack Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        20: {
            'function_id': 20,
            'name': 'Get External Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        22: {
            'function_id': 22,
            'name': 'Set Motor Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        23: {
            'function_id': 23,
            'name': 'Get Motor Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        24: {
            'function_id': 24,
            'name': 'Enable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        25: {
            'function_id': 25,
            'name': 'Disable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        26: {
            'function_id': 26,
            'name': 'Is Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        27: {
            'function_id': 27,
            'name': 'Set Basic Configuration',
            'elements': [
                {
                    'name': 'Standstill Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Motor Run Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Standstill Delay Time',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Power Down Time',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stealth Threshold',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Coolstep Threshold',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Classic Threshold',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'High Velocity Chopper Mode',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H H H H H H !',
            'out_struct_format': '',
        },
        28: {
            'function_id': 28,
            'name': 'Get Basic Configuration',
            'elements': [
                {
                    'name': 'Standstill Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Motor Run Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Standstill Delay Time',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Power Down Time',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stealth Threshold',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Coolstep Threshold',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Classic Threshold',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'High Velocity Chopper Mode',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H H H H !',
        },
        29: {
            'function_id': 29,
            'name': 'Set Spreadcycle Configuration',
            'elements': [
                {
                    'name': 'Slow Decay Duration',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enable Random Slow Decay',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Fast Decay Duration',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Hysteresis Start Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Hysteresis End Value',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Sine Wave Offset',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chopper Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Comparator Blank Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Fast Decay Without Comparator',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! B B b b B B !',
            'out_struct_format': '',
        },
        30: {
            'function_id': 30,
            'name': 'Get Spreadcycle Configuration',
            'elements': [
                {
                    'name': 'Slow Decay Duration',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enable Random Slow Decay',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Fast Decay Duration',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hysteresis Start Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hysteresis End Value',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Sine Wave Offset',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Chopper Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Comparator Blank Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Fast Decay Without Comparator',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B ! B B b b B B !',
        },
        31: {
            'function_id': 31,
            'name': 'Set Stealth Configuration',
            'elements': [
                {
                    'name': 'Enable Stealth',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Amplitude',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Gradient',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enable Autoscale',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Force Symmetric',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Freewheel Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! B B ! ! B',
            'out_struct_format': '',
        },
        32: {
            'function_id': 32,
            'name': 'Get Stealth Configuration',
            'elements': [
                {
                    'name': 'Enable Stealth',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Amplitude',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Gradient',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enable Autoscale',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Force Symmetric',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Freewheel Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! B B ! ! B',
        },
        33: {
            'function_id': 33,
            'name': 'Set Coolstep Configuration',
            'elements': [
                {
                    'name': 'Minimum Stallguard Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Maximum Stallguard Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current Up Step Width',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current Down Step Width',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Current',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stallguard Threshold Value',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stallguard Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B B b B',
            'out_struct_format': '',
        },
        34: {
            'function_id': 34,
            'name': 'Get Coolstep Configuration',
            'elements': [
                {
                    'name': 'Minimum Stallguard Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Maximum Stallguard Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Up Step Width',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Down Step Width',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Current',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stallguard Threshold Value',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stallguard Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B B B b B',
        },
        35: {
            'function_id': 35,
            'name': 'Set Misc Configuration',
            'elements': [
                {
                    'name': 'Disable Short To Ground Protection',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Synchronize Phase Frequency',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! B',
            'out_struct_format': '',
        },
        36: {
            'function_id': 36,
            'name': 'Get Misc Configuration',
            'elements': [
                {
                    'name': 'Disable Short To Ground Protection',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Synchronize Phase Frequency',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! B',
        },
        37: {
            'function_id': 37,
            'name': 'Get Driver Status',
            'elements': [
                {
                    'name': 'Open Load',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Short To Ground',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Over Temperature',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Motor Stalled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Actual Motor Current',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Full Step Active',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stallguard Result',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stealth Voltage Amplitude',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B ! B ! B B',
        },
        38: {
            'function_id': 38,
            'name': 'Set Minimum Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        39: {
            'function_id': 39,
            'name': 'Get Minimum Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        40: {
            'function_id': 40,
            'name': 'Under Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        41: {
            'function_id': 41,
            'name': 'Position Reached',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        42: {
            'function_id': 42,
            'name': 'Set Time Base',
            'elements': [
                {
                    'name': 'Time Base',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        43: {
            'function_id': 43,
            'name': 'Get Time Base',
            'elements': [
                {
                    'name': 'Time Base',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        44: {
            'function_id': 44,
            'name': 'Get All Data',
            'elements': [
                {
                    'name': 'Current Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Remaining Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stack Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'External Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Consumption',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H i i H H H',
        },
        45: {
            'function_id': 45,
            'name': 'Set All Data Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        46: {
            'function_id': 46,
            'name': 'Get All Data Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        47: {
            'function_id': 47,
            'name': 'All Data',
            'elements': [
                {
                    'name': 'Current Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Remaining Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stack Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'External Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Consumption',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H i i H H H',
        },
        48: {
            'function_id': 48,
            'name': 'New State',
            'elements': [
                {
                    'name': 'State New',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'State Previous',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        231: {
            'function_id': 231,
            'name': 'Set SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        232: {
            'function_id': 232,
            'name': 'Get SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I',
        },
        233: {
            'function_id': 233,
            'name': 'Get Send Timeout Count',
            'elements': [
                {
                    'name': 'Communication Method',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Timeout Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Set SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c I',
            'out_struct_format': '',
        },
        235: {
            'function_id': 235,
            'name': 'Get SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I',
        },
        237: {
            'function_id': 237,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Count ACK Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I I I I',
        },
        238: {
            'function_id': 238,
            'name': 'Enable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        239: {
            'function_id': 239,
            'name': 'Disable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Is Status LED Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        241: {
            'function_id': 241,
            'name': 'Get Protocol1 Bricklet Name',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Protocol Version',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Name',
                    'type': 'string',
                    'cardinality': '40',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B 3B 40s',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        246: {
            'function_id': 246,
            'name': 'Write Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B 32B',
            'out_struct_format': '',
        },
        247: {
            'function_id': 247,
            'name': 'Read Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': '32B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
15: {
    'device_identifier': 15,
    'name': 'Stepper Brick',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Max Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Max Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Get Current Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        4: {
            'function_id': 4,
            'name': 'Set Speed Ramping',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Deacceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Speed Ramping',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Deacceleration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        6: {
            'function_id': 6,
            'name': 'Full Brake',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Set Current Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Current Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        9: {
            'function_id': 9,
            'name': 'Set Target Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Target Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        11: {
            'function_id': 11,
            'name': 'Set Steps',
            'elements': [
                {
                    'name': 'Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Steps',
            'elements': [
                {
                    'name': 'Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        13: {
            'function_id': 13,
            'name': 'Get Remaining Steps',
            'elements': [
                {
                    'name': 'Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        14: {
            'function_id': 14,
            'name': 'Set Step Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Step Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        16: {
            'function_id': 16,
            'name': 'Drive Forward',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Drive Backward',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Stop',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        19: {
            'function_id': 19,
            'name': 'Get Stack Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        20: {
            'function_id': 20,
            'name': 'Get External Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        21: {
            'function_id': 21,
            'name': 'Get Current Consumption',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        22: {
            'function_id': 22,
            'name': 'Set Motor Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        23: {
            'function_id': 23,
            'name': 'Get Motor Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        24: {
            'function_id': 24,
            'name': 'Enable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        25: {
            'function_id': 25,
            'name': 'Disable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        26: {
            'function_id': 26,
            'name': 'Is Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        27: {
            'function_id': 27,
            'name': 'Set Decay',
            'elements': [
                {
                    'name': 'Decay',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        28: {
            'function_id': 28,
            'name': 'Get Decay',
            'elements': [
                {
                    'name': 'Decay',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        29: {
            'function_id': 29,
            'name': 'Set Minimum Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        30: {
            'function_id': 30,
            'name': 'Get Minimum Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        31: {
            'function_id': 31,
            'name': 'Under Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        32: {
            'function_id': 32,
            'name': 'Position Reached',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        33: {
            'function_id': 33,
            'name': 'Set Sync Rect',
            'elements': [
                {
                    'name': 'Sync Rect',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        34: {
            'function_id': 34,
            'name': 'Is Sync Rect',
            'elements': [
                {
                    'name': 'Sync Rect',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        35: {
            'function_id': 35,
            'name': 'Set Time Base',
            'elements': [
                {
                    'name': 'Time Base',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        36: {
            'function_id': 36,
            'name': 'Get Time Base',
            'elements': [
                {
                    'name': 'Time Base',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        37: {
            'function_id': 37,
            'name': 'Get All Data',
            'elements': [
                {
                    'name': 'Current Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Remaining Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stack Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'External Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Consumption',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H i i H H H',
        },
        38: {
            'function_id': 38,
            'name': 'Set All Data Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        39: {
            'function_id': 39,
            'name': 'Get All Data Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        40: {
            'function_id': 40,
            'name': 'All Data',
            'elements': [
                {
                    'name': 'Current Velocity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Position',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Remaining Steps',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stack Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'External Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Consumption',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H i i H H H',
        },
        41: {
            'function_id': 41,
            'name': 'New State',
            'elements': [
                {
                    'name': 'State New',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'State Previous',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        231: {
            'function_id': 231,
            'name': 'Set SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        232: {
            'function_id': 232,
            'name': 'Get SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I',
        },
        233: {
            'function_id': 233,
            'name': 'Get Send Timeout Count',
            'elements': [
                {
                    'name': 'Communication Method',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Timeout Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Set SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c I',
            'out_struct_format': '',
        },
        235: {
            'function_id': 235,
            'name': 'Get SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I',
        },
        237: {
            'function_id': 237,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Bricklet Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Error Count ACK Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'I I I I',
        },
        238: {
            'function_id': 238,
            'name': 'Enable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        239: {
            'function_id': 239,
            'name': 'Disable Status LED',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Is Status LED Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        241: {
            'function_id': 241,
            'name': 'Get Protocol1 Bricklet Name',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Protocol Version',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Name',
                    'type': 'string',
                    'cardinality': '40',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B 3B 40s',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        246: {
            'function_id': 246,
            'name': 'Write Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B 32B',
            'out_struct_format': '',
        },
        247: {
            'function_id': 247,
            'name': 'Read Bricklet Plugin',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Offset',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Chunk',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': '32B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
250: {
    'device_identifier': 250,
    'name': 'Accelerometer Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        2: {
            'function_id': 2,
            'name': 'Set Acceleration Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Acceleration Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Acceleration Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c h h h h h h',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Acceleration Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c h h h h h h',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        9: {
            'function_id': 9,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Data Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Full Scale',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Filter Bandwidth',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Data Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Full Scale',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Filter Bandwidth',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        11: {
            'function_id': 11,
            'name': 'LED On',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'LED Off',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Is LED On',
            'elements': [
                {
                    'name': 'On',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        14: {
            'function_id': 14,
            'name': 'Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        15: {
            'function_id': 15,
            'name': 'Acceleration Reached',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h h',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2130: {
    'device_identifier': 2130,
    'name': 'Accelerometer Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Data Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Full Scale',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Data Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Full Scale',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        4: {
            'function_id': 4,
            'name': 'Set Acceleration Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Acceleration Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        6: {
            'function_id': 6,
            'name': 'Set Info LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Info LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        8: {
            'function_id': 8,
            'name': 'Acceleration',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i i',
        },
        9: {
            'function_id': 9,
            'name': 'Set Continuous Acceleration Configuration',
            'elements': [
                {
                    'name': 'Enable X',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enable Y',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enable Z',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Resolution',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! ! ! B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Continuous Acceleration Configuration',
            'elements': [
                {
                    'name': 'Enable X',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enable Y',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enable Z',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Resolution',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! ! ! B',
        },
        11: {
            'function_id': 11,
            'name': 'Continuous Acceleration 16 Bit',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'int16',
                    'cardinality': '30',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '30h',
        },
        12: {
            'function_id': 12,
            'name': 'Continuous Acceleration 8 Bit',
            'elements': [
                {
                    'name': 'Acceleration',
                    'type': 'int8',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '60b',
        },
        13: {
            'function_id': 13,
            'name': 'Set Filter Configuration',
            'elements': [
                {
                    'name': 'IIR Bypass',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Low Pass Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Filter Configuration',
            'elements': [
                {
                    'name': 'IIR Bypass',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Low Pass Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
297: {
    'device_identifier': 297,
    'name': 'Air Quality Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get All Values',
            'elements': [
                {
                    'name': 'IAQ Index',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'IAQ Index Accuracy',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Humidity',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i B i i i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Temperature Offset',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Temperature Offset',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        4: {
            'function_id': 4,
            'name': 'Set All Values Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get All Values Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        6: {
            'function_id': 6,
            'name': 'All Values',
            'elements': [
                {
                    'name': 'IAQ Index',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'IAQ Index Accuracy',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Humidity',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i B i i i',
        },
        7: {
            'function_id': 7,
            'name': 'Get IAQ Index',
            'elements': [
                {
                    'name': 'IAQ Index',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'IAQ Index Accuracy',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i B',
        },
        8: {
            'function_id': 8,
            'name': 'Set IAQ Index Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get IAQ Index Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        10: {
            'function_id': 10,
            'name': 'IAQ Index',
            'elements': [
                {
                    'name': 'IAQ Index',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'IAQ Index Accuracy',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i B',
        },
        11: {
            'function_id': 11,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        12: {
            'function_id': 12,
            'name': 'Set Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        14: {
            'function_id': 14,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        15: {
            'function_id': 15,
            'name': 'Get Humidity',
            'elements': [
                {
                    'name': 'Humidity',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        16: {
            'function_id': 16,
            'name': 'Set Humidity Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Get Humidity Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        18: {
            'function_id': 18,
            'name': 'Humidity',
            'elements': [
                {
                    'name': 'Humidity',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        19: {
            'function_id': 19,
            'name': 'Get Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        20: {
            'function_id': 20,
            'name': 'Set Air Pressure Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        21: {
            'function_id': 21,
            'name': 'Get Air Pressure Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        22: {
            'function_id': 22,
            'name': 'Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        23: {
            'function_id': 23,
            'name': 'Remove Calibration',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        24: {
            'function_id': 24,
            'name': 'Set Background Calibration Duration',
            'elements': [
                {
                    'name': 'Duration',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        25: {
            'function_id': 25,
            'name': 'Get Background Calibration Duration',
            'elements': [
                {
                    'name': 'Duration',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
21: {
    'device_identifier': 21,
    'name': 'Ambient Light Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Illuminance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Illuminance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Illuminance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Illuminance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        14: {
            'function_id': 14,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        15: {
            'function_id': 15,
            'name': 'Illuminance Reached',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
259: {
    'device_identifier': 259,
    'name': 'Ambient Light Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        2: {
            'function_id': 2,
            'name': 'Set Illuminance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Illuminance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Illuminance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c I I',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Illuminance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c I I',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Illuminance Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Illuminance Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        10: {
            'function_id': 10,
            'name': 'Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        11: {
            'function_id': 11,
            'name': 'Illuminance Reached',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2131: {
    'device_identifier': 2131,
    'name': 'Ambient Light Bricklet 3.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        2: {
            'function_id': 2,
            'name': 'Set Illuminance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c I I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Illuminance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c I I',
        },
        4: {
            'function_id': 4,
            'name': 'Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Illuminance Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Illuminance Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
219: {
    'device_identifier': 219,
    'name': 'Analog In Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        14: {
            'function_id': 14,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        15: {
            'function_id': 15,
            'name': 'Voltage Reached',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        17: {
            'function_id': 17,
            'name': 'Set Range',
            'elements': [
                {
                    'name': 'Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Range',
            'elements': [
                {
                    'name': 'Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        19: {
            'function_id': 19,
            'name': 'Set Averaging',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Get Averaging',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
251: {
    'device_identifier': 251,
    'name': 'Analog In Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Set Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        15: {
            'function_id': 15,
            'name': 'Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        17: {
            'function_id': 17,
            'name': 'Voltage Reached',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        18: {
            'function_id': 18,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
295: {
    'device_identifier': 295,
    'name': 'Analog In Bricklet 3.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Voltage Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Voltage Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        4: {
            'function_id': 4,
            'name': 'Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Set Oversampling',
            'elements': [
                {
                    'name': 'Oversampling',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Oversampling',
            'elements': [
                {
                    'name': 'Oversampling',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        7: {
            'function_id': 7,
            'name': 'Set Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Multiplier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Divisor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'h H H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Multiplier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Divisor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h H H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
220: {
    'device_identifier': 220,
    'name': 'Analog Out Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
256: {
    'device_identifier': 256,
    'name': 'Analog Out Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Output Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Output Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Get Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2115: {
    'device_identifier': 2115,
    'name': 'Analog Out Bricklet 3.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Output Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Output Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Get Input Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
221: {
    'device_identifier': 221,
    'name': 'Barometer Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Get Altitude',
            'elements': [
                {
                    'name': 'Altitude',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        3: {
            'function_id': 3,
            'name': 'Set Air Pressure Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Air Pressure Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Altitude Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Altitude Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Air Pressure Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Air Pressure Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        9: {
            'function_id': 9,
            'name': 'Set Altitude Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Altitude Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Set Reference Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        15: {
            'function_id': 15,
            'name': 'Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        16: {
            'function_id': 16,
            'name': 'Altitude',
            'elements': [
                {
                    'name': 'Altitude',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        17: {
            'function_id': 17,
            'name': 'Air Pressure Reached',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        18: {
            'function_id': 18,
            'name': 'Altitude Reached',
            'elements': [
                {
                    'name': 'Altitude',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        19: {
            'function_id': 19,
            'name': 'Get Reference Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        20: {
            'function_id': 20,
            'name': 'Set Averaging',
            'elements': [
                {
                    'name': 'Moving Average Pressure',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Average Pressure',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Average Temperature',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        21: {
            'function_id': 21,
            'name': 'Get Averaging',
            'elements': [
                {
                    'name': 'Moving Average Pressure',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Average Pressure',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Average Temperature',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        22: {
            'function_id': 22,
            'name': 'Set I2C Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        23: {
            'function_id': 23,
            'name': 'Get I2C Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2117: {
    'device_identifier': 2117,
    'name': 'Barometer Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Air Pressure Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Air Pressure Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        4: {
            'function_id': 4,
            'name': 'Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        5: {
            'function_id': 5,
            'name': 'Get Altitude',
            'elements': [
                {
                    'name': 'Altitude',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        6: {
            'function_id': 6,
            'name': 'Set Altitude Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Altitude Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        8: {
            'function_id': 8,
            'name': 'Altitude',
            'elements': [
                {
                    'name': 'Altitude',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        9: {
            'function_id': 9,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        10: {
            'function_id': 10,
            'name': 'Set Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        12: {
            'function_id': 12,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        13: {
            'function_id': 13,
            'name': 'Set Moving Average Configuration',
            'elements': [
                {
                    'name': 'Moving Average Length Air Pressure',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Moving Average Length Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Moving Average Configuration',
            'elements': [
                {
                    'name': 'Moving Average Length Air Pressure',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Moving Average Length Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        15: {
            'function_id': 15,
            'name': 'Set Reference Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Reference Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        17: {
            'function_id': 17,
            'name': 'Set Calibration',
            'elements': [
                {
                    'name': 'Measured Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Actual Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i i',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Calibration',
            'elements': [
                {
                    'name': 'Measured Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Actual Air Pressure',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i',
        },
        19: {
            'function_id': 19,
            'name': 'Set Sensor Configuration',
            'elements': [
                {
                    'name': 'Data Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Air Pressure Low Pass Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Get Sensor Configuration',
            'elements': [
                {
                    'name': 'Data Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Air Pressure Low Pass Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
270: {
    'device_identifier': 270,
    'name': 'CAN Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write Frame',
            'elements': [
                {
                    'name': 'Frame Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Identifier',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '8',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Success',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I 8B B',
            'out_struct_format': '!',
        },
        2: {
            'function_id': 2,
            'name': 'Read Frame',
            'elements': [
                {
                    'name': 'Success',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifier',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! B I 8B B',
        },
        3: {
            'function_id': 3,
            'name': 'Enable Frame Read Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Disable Frame Read Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Is Frame Read Callback Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        6: {
            'function_id': 6,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Baud Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Transceiver Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Write Timeout',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B i',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Baud Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Write Timeout',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B i',
        },
        8: {
            'function_id': 8,
            'name': 'Set Read Filter',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Mask',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Filter1',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Filter2',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I I I',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Read Filter',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Mask',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Filter1',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Filter2',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I I I',
        },
        10: {
            'function_id': 10,
            'name': 'Get Error Log',
            'elements': [
                {
                    'name': 'Write Error Level',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Read Error Level',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver Disabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Write Timeout Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Read Register Overflow Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Read Buffer Overflow Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B ! I I I',
        },
        11: {
            'function_id': 11,
            'name': 'Frame Read',
            'elements': [
                {
                    'name': 'Frame Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifier',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I 8B B',
        },
        12: {
            'function_id': 12,
            'name': 'Set Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        14: {
            'function_id': 14,
            'name': 'Frame Readable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2107: {
    'device_identifier': 2107,
    'name': 'CAN Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write Frame Low Level',
            'elements': [
                {
                    'name': 'Frame Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Identifier',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data Data',
                    'type': 'uint8',
                    'cardinality': '15',
                    'direction': 'in'
                },
                {
                    'name': 'Success',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I B 15B',
            'out_struct_format': '!',
        },
        2: {
            'function_id': 2,
            'name': 'Read Frame Low Level',
            'elements': [
                {
                    'name': 'Success',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifier',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data Data',
                    'type': 'uint8',
                    'cardinality': '15',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! B I B 15B',
        },
        3: {
            'function_id': 3,
            'name': 'Set Frame Read Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Frame Read Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        5: {
            'function_id': 5,
            'name': 'Set Transceiver Configuration',
            'elements': [
                {
                    'name': 'Baud Rate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Sample Point',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Transceiver Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I H B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Transceiver Configuration',
            'elements': [
                {
                    'name': 'Baud Rate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Sample Point',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I H B',
        },
        7: {
            'function_id': 7,
            'name': 'Set Queue Configuration Low Level',
            'elements': [
                {
                    'name': 'Write Buffer Size',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Write Buffer Timeout',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Write Backlog Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Read Buffer Sizes Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Read Buffer Sizes Data',
                    'type': 'int8',
                    'cardinality': '32',
                    'direction': 'in'
                },
                {
                    'name': 'Read Backlog Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B i H B 32b H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Queue Configuration Low Level',
            'elements': [
                {
                    'name': 'Write Buffer Size',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Write Buffer Timeout',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Write Backlog Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Read Buffer Sizes Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Read Buffer Sizes Data',
                    'type': 'int8',
                    'cardinality': '32',
                    'direction': 'out'
                },
                {
                    'name': 'Read Backlog Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B i H B 32b H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Read Filter Configuration',
            'elements': [
                {
                    'name': 'Buffer Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Filter Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Filter Mask',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Filter Identifier',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B I I',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Read Filter Configuration',
            'elements': [
                {
                    'name': 'Buffer Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Filter Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Filter Mask',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Filter Identifier',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B I I',
        },
        11: {
            'function_id': 11,
            'name': 'Get Error Log Low Level',
            'elements': [
                {
                    'name': 'Transceiver State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver Write Error Level',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver Read Error Level',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver Stuffing Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver Format Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver ACK Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver Bit1 Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver Bit0 Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Transceiver CRC Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Write Buffer Timeout Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Read Buffer Overflow Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Read Buffer Overflow Error Occurred Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Read Buffer Overflow Error Occurred Data',
                    'type': 'bool',
                    'cardinality': '32',
                    'direction': 'out'
                },
                {
                    'name': 'Read Backlog Overflow Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B I I I I I I I I B 32! I',
        },
        12: {
            'function_id': 12,
            'name': 'Set Communication LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Communication LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        14: {
            'function_id': 14,
            'name': 'Set Error LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Error LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        16: {
            'function_id': 16,
            'name': 'Frame Read Low Level',
            'elements': [
                {
                    'name': 'Frame Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifier',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data Data',
                    'type': 'uint8',
                    'cardinality': '15',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I B 15B',
        },
        17: {
            'function_id': 17,
            'name': 'Set Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        19: {
            'function_id': 19,
            'name': 'Frame Readable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Set Error Occurred Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        21: {
            'function_id': 21,
            'name': 'Get Error Occurred Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        22: {
            'function_id': 22,
            'name': 'Error Occurred',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
262: {
    'device_identifier': 262,
    'name': 'CO2 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get CO2 Concentration',
            'elements': [
                {
                    'name': 'CO2 Concentration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set CO2 Concentration Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get CO2 Concentration Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set CO2 Concentration Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get CO2 Concentration Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'CO2 Concentration',
            'elements': [
                {
                    'name': 'CO2 Concentration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        9: {
            'function_id': 9,
            'name': 'CO2 Concentration Reached',
            'elements': [
                {
                    'name': 'CO2 Concentration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2147: {
    'device_identifier': 2147,
    'name': 'CO2 Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get All Values',
            'elements': [
                {
                    'name': 'CO2 Concentration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H h H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Air Pressure',
            'elements': [
                {
                    'name': 'Air Pressure',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        4: {
            'function_id': 4,
            'name': 'Set Temperature Offset',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Temperature Offset',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        6: {
            'function_id': 6,
            'name': 'Set All Values Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get All Values Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        8: {
            'function_id': 8,
            'name': 'All Values',
            'elements': [
                {
                    'name': 'CO2 Concentration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H h H',
        },
        9: {
            'function_id': 9,
            'name': 'Get CO2 Concentration',
            'elements': [
                {
                    'name': 'CO2 Concentration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        10: {
            'function_id': 10,
            'name': 'Set CO2 Concentration Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get CO2 Concentration Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        12: {
            'function_id': 12,
            'name': 'CO2 Concentration',
            'elements': [
                {
                    'name': 'CO2 Concentration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        13: {
            'function_id': 13,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        14: {
            'function_id': 14,
            'name': 'Set Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        16: {
            'function_id': 16,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        17: {
            'function_id': 17,
            'name': 'Get Humidity',
            'elements': [
                {
                    'name': 'Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        18: {
            'function_id': 18,
            'name': 'Set Humidity Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        19: {
            'function_id': 19,
            'name': 'Get Humidity Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        20: {
            'function_id': 20,
            'name': 'Humidity',
            'elements': [
                {
                    'name': 'Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
243: {
    'device_identifier': 243,
    'name': 'Color Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Color',
            'elements': [
                {
                    'name': 'R',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'G',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'B',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'C',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Color Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Color Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Color Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min R',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max R',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min G',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max G',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min B',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max B',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min C',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max C',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H H H H H H H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Color Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min R',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max R',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min G',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max G',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min B',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max B',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min C',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max C',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H H H H H H H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Color',
            'elements': [
                {
                    'name': 'R',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'G',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'B',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'C',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H',
        },
        9: {
            'function_id': 9,
            'name': 'Color Reached',
            'elements': [
                {
                    'name': 'R',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'G',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'B',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'C',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H',
        },
        10: {
            'function_id': 10,
            'name': 'Light On',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Light Off',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Is Light On',
            'elements': [
                {
                    'name': 'Light',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        13: {
            'function_id': 13,
            'name': 'Set Config',
            'elements': [
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Config',
            'elements': [
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        15: {
            'function_id': 15,
            'name': 'Get Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        16: {
            'function_id': 16,
            'name': 'Get Color Temperature',
            'elements': [
                {
                    'name': 'Color Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        17: {
            'function_id': 17,
            'name': 'Set Illuminance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Illuminance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        19: {
            'function_id': 19,
            'name': 'Set Color Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Get Color Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        21: {
            'function_id': 21,
            'name': 'Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        22: {
            'function_id': 22,
            'name': 'Color Temperature',
            'elements': [
                {
                    'name': 'Color Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2128: {
    'device_identifier': 2128,
    'name': 'Color Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Color',
            'elements': [
                {
                    'name': 'R',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'G',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'B',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'C',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Color Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Color Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        4: {
            'function_id': 4,
            'name': 'Color',
            'elements': [
                {
                    'name': 'R',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'G',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'B',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'C',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H',
        },
        5: {
            'function_id': 5,
            'name': 'Get Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        6: {
            'function_id': 6,
            'name': 'Set Illuminance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c I I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Illuminance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c I I',
        },
        8: {
            'function_id': 8,
            'name': 'Illuminance',
            'elements': [
                {
                    'name': 'Illuminance',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Get Color Temperature',
            'elements': [
                {
                    'name': 'Color Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        10: {
            'function_id': 10,
            'name': 'Set Color Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Color Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        12: {
            'function_id': 12,
            'name': 'Color Temperature',
            'elements': [
                {
                    'name': 'Color Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        13: {
            'function_id': 13,
            'name': 'Set Light',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Light',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        15: {
            'function_id': 15,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2153: {
    'device_identifier': 2153,
    'name': 'Compass Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Heading',
            'elements': [
                {
                    'name': 'Heading',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Set Heading Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Heading Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        4: {
            'function_id': 4,
            'name': 'Heading',
            'elements': [
                {
                    'name': 'Heading',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        5: {
            'function_id': 5,
            'name': 'Get Magnetic Flux Density',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i i',
        },
        6: {
            'function_id': 6,
            'name': 'Set Magnetic Flux Density Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Magnetic Flux Density Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        8: {
            'function_id': 8,
            'name': 'Magnetic Flux Density',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Z',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i i',
        },
        9: {
            'function_id': 9,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Data Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Background Calibration',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Data Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Background Calibration',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        11: {
            'function_id': 11,
            'name': 'Set Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'in'
                },
                {
                    'name': 'Gain',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '3h 3h',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Gain',
                    'type': 'int16',
                    'cardinality': '3',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '3h 3h',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
23: {
    'device_identifier': 23,
    'name': 'Current12 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Calibrate',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Is Over Current',
            'elements': [
                {
                    'name': 'Over',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        4: {
            'function_id': 4,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Set Current Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Current Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Current Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c h h',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Current Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c h h',
        },
        11: {
            'function_id': 11,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        13: {
            'function_id': 13,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        15: {
            'function_id': 15,
            'name': 'Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        17: {
            'function_id': 17,
            'name': 'Current Reached',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        18: {
            'function_id': 18,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        19: {
            'function_id': 19,
            'name': 'Over Current',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
24: {
    'device_identifier': 24,
    'name': 'Current25 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Calibrate',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Is Over Current',
            'elements': [
                {
                    'name': 'Over',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        4: {
            'function_id': 4,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Set Current Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Current Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Current Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c h h',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Current Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c h h',
        },
        11: {
            'function_id': 11,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        13: {
            'function_id': 13,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        15: {
            'function_id': 15,
            'name': 'Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        17: {
            'function_id': 17,
            'name': 'Current Reached',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        18: {
            'function_id': 18,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        19: {
            'function_id': 19,
            'name': 'Over Current',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
25: {
    'device_identifier': 25,
    'name': 'Distance IR Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Sampling Point',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Sampling Point',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Set Distance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Distance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Distance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Distance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        13: {
            'function_id': 13,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        15: {
            'function_id': 15,
            'name': 'Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        17: {
            'function_id': 17,
            'name': 'Distance Reached',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        18: {
            'function_id': 18,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2125: {
    'device_identifier': 2125,
    'name': 'Distance IR Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Distance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Distance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        4: {
            'function_id': 4,
            'name': 'Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Analog Value',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        6: {
            'function_id': 6,
            'name': 'Set Analog Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c I I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Analog Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c I I',
        },
        8: {
            'function_id': 8,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Analog Value',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Moving Average Configuration',
            'elements': [
                {
                    'name': 'Moving Average Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Moving Average Configuration',
            'elements': [
                {
                    'name': 'Moving Average Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Distance LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Distance LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        13: {
            'function_id': 13,
            'name': 'Set Sensor Type',
            'elements': [
                {
                    'name': 'Sensor',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Sensor Type',
            'elements': [
                {
                    'name': 'Sensor',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
229: {
    'device_identifier': 229,
    'name': 'Distance US Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Distance Value',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Distance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Distance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Distance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Distance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        9: {
            'function_id': 9,
            'name': 'Distance Reached',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        10: {
            'function_id': 10,
            'name': 'Set Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
299: {
    'device_identifier': 299,
    'name': 'Distance US Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Distance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Distance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        4: {
            'function_id': 4,
            'name': 'Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Set Update Rate',
            'elements': [
                {
                    'name': 'Update Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Update Rate',
            'elements': [
                {
                    'name': 'Update Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        7: {
            'function_id': 7,
            'name': 'Set Distance LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Distance LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
285: {
    'device_identifier': 285,
    'name': 'DMX Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set DMX Mode',
            'elements': [
                {
                    'name': 'DMX Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get DMX Mode',
            'elements': [
                {
                    'name': 'DMX Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        3: {
            'function_id': 3,
            'name': 'Write Frame Low Level',
            'elements': [
                {
                    'name': 'Frame Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frame Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frame Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H 60B',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Read Frame Low Level',
            'elements': [
                {
                    'name': 'Frame Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Chunk Data',
                    'type': 'uint8',
                    'cardinality': '56',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Number',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 56B I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Frame Duration',
            'elements': [
                {
                    'name': 'Frame Duration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Frame Duration',
            'elements': [
                {
                    'name': 'Frame Duration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        7: {
            'function_id': 7,
            'name': 'Get Frame Error Count',
            'elements': [
                {
                    'name': 'Overrun Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Framing Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        8: {
            'function_id': 8,
            'name': 'Set Communication LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Communication LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        10: {
            'function_id': 10,
            'name': 'Set Error LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Error LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        12: {
            'function_id': 12,
            'name': 'Set Frame Callback Config',
            'elements': [
                {
                    'name': 'Frame Started Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frame Available Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frame Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frame Error Count Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! ! ! !',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Frame Callback Config',
            'elements': [
                {
                    'name': 'Frame Started Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Available Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Error Count Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! ! ! !',
        },
        14: {
            'function_id': 14,
            'name': 'Frame Started',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Frame Available',
            'elements': [
                {
                    'name': 'Frame Number',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        16: {
            'function_id': 16,
            'name': 'Frame Low Level',
            'elements': [
                {
                    'name': 'Frame Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Chunk Data',
                    'type': 'uint8',
                    'cardinality': '56',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Number',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 56B I',
        },
        17: {
            'function_id': 17,
            'name': 'Frame Error Count',
            'elements': [
                {
                    'name': 'Overrun Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Framing Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
230: {
    'device_identifier': 230,
    'name': 'Dual Button Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set LED State',
            'elements': [
                {
                    'name': 'LED L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'LED R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get LED State',
            'elements': [
                {
                    'name': 'LED L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'LED R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        3: {
            'function_id': 3,
            'name': 'Get Button State',
            'elements': [
                {
                    'name': 'Button L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Button R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        4: {
            'function_id': 4,
            'name': 'State Changed',
            'elements': [
                {
                    'name': 'Button L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Button R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'LED L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'LED R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B B',
        },
        5: {
            'function_id': 5,
            'name': 'Set Selected LED State',
            'elements': [
                {
                    'name': 'LED',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2119: {
    'device_identifier': 2119,
    'name': 'Dual Button Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set LED State',
            'elements': [
                {
                    'name': 'LED L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'LED R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get LED State',
            'elements': [
                {
                    'name': 'LED L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'LED R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        3: {
            'function_id': 3,
            'name': 'Get Button State',
            'elements': [
                {
                    'name': 'Button L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Button R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        4: {
            'function_id': 4,
            'name': 'State Changed',
            'elements': [
                {
                    'name': 'Button L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Button R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'LED L',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'LED R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B B',
        },
        5: {
            'function_id': 5,
            'name': 'Set Selected LED State',
            'elements': [
                {
                    'name': 'LED',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Set State Changed Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get State Changed Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
26: {
    'device_identifier': 26,
    'name': 'Dual Relay Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set State',
            'elements': [
                {
                    'name': 'Relay1',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Relay2',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! !',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get State',
            'elements': [
                {
                    'name': 'Relay1',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Relay2',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! !',
        },
        3: {
            'function_id': 3,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'Relay',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'Relay',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! I I',
        },
        5: {
            'function_id': 5,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Relay',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        6: {
            'function_id': 6,
            'name': 'Set Selected State',
            'elements': [
                {
                    'name': 'Relay',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
260: {
    'device_identifier': 260,
    'name': 'Dust Detector Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Dust Density',
            'elements': [
                {
                    'name': 'Dust Density',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Dust Density Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Dust Density Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Dust Density Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Dust Density Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Dust Density',
            'elements': [
                {
                    'name': 'Dust Density',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        9: {
            'function_id': 9,
            'name': 'Dust Density Reached',
            'elements': [
                {
                    'name': 'Dust Density',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        10: {
            'function_id': 10,
            'name': 'Set Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2146: {
    'device_identifier': 2146,
    'name': 'E-Paper 296x128 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Draw',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Draw Status',
            'elements': [
                {
                    'name': 'Draw Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        3: {
            'function_id': 3,
            'name': 'Write Black White Low Level',
            'elements': [
                {
                    'name': 'X Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'X End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Chunk Data',
                    'type': 'bool',
                    'cardinality': '432',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B H B H H 432!',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Read Black White Low Level',
            'elements': [
                {
                    'name': 'X Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'X End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pixels Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pixels Chunk Data',
                    'type': 'bool',
                    'cardinality': '464',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H B H B',
            'out_struct_format': 'H H 464!',
        },
        5: {
            'function_id': 5,
            'name': 'Write Color Low Level',
            'elements': [
                {
                    'name': 'X Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'X End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Chunk Data',
                    'type': 'bool',
                    'cardinality': '432',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B H B H H 432!',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Read Color Low Level',
            'elements': [
                {
                    'name': 'X Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'X End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pixels Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pixels Chunk Data',
                    'type': 'bool',
                    'cardinality': '464',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H B H B',
            'out_struct_format': 'H H 464!',
        },
        7: {
            'function_id': 7,
            'name': 'Fill Display',
            'elements': [
                {
                    'name': 'Color',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Draw Text',
            'elements': [
                {
                    'name': 'Position X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Font',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Color',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Orientation',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '50',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B B B B 50s',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Draw Line',
            'elements': [
                {
                    'name': 'Position X Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position X End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Color',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B H B B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Draw Box',
            'elements': [
                {
                    'name': 'Position X Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position X End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Fill',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Color',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B H B ! B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Draw Status',
            'elements': [
                {
                    'name': 'Draw Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        12: {
            'function_id': 12,
            'name': 'Set Update Mode',
            'elements': [
                {
                    'name': 'Update Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Update Mode',
            'elements': [
                {
                    'name': 'Update Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        14: {
            'function_id': 14,
            'name': 'Set Display Type',
            'elements': [
                {
                    'name': 'Display Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Display Type',
            'elements': [
                {
                    'name': 'Display Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2152: {
    'device_identifier': 2152,
    'name': 'Energy Monitor Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Energy Data',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Energy',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Real Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Apparent Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Reactive Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Power Factor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i i i i i H H',
        },
        2: {
            'function_id': 2,
            'name': 'Reset Energy',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Waveform Low Level',
            'elements': [
                {
                    'name': 'Waveform Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Waveform Chunk Data',
                    'type': 'int16',
                    'cardinality': '30',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H 30h',
        },
        4: {
            'function_id': 4,
            'name': 'Get Transformer Status',
            'elements': [
                {
                    'name': 'Voltage Transformer Connected',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Transformer Connected',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! !',
        },
        5: {
            'function_id': 5,
            'name': 'Set Transformer Calibration',
            'elements': [
                {
                    'name': 'Voltage Ratio',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current Ratio',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Phase Shift',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H h',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Transformer Calibration',
            'elements': [
                {
                    'name': 'Voltage Ratio',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Ratio',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Phase Shift',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H h',
        },
        7: {
            'function_id': 7,
            'name': 'Calibrate Offset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Set Energy Data Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Energy Data Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        10: {
            'function_id': 10,
            'name': 'Energy Data',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Energy',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Real Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Apparent Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Reactive Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Power Factor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i i i i i H H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
222: {
    'device_identifier': 222,
    'name': 'GPS Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Coordinates',
            'elements': [
                {
                    'name': 'Latitude',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'NS',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Longitude',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'EW',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'PDOP',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'HDOP',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'VDOP',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'EPE',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I c I c H H H H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Status',
            'elements': [
                {
                    'name': 'Fix',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Satellites View',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Satellites Used',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        3: {
            'function_id': 3,
            'name': 'Get Altitude',
            'elements': [
                {
                    'name': 'Altitude',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Geoidal Separation',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i',
        },
        4: {
            'function_id': 4,
            'name': 'Get Motion',
            'elements': [
                {
                    'name': 'Course',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        5: {
            'function_id': 5,
            'name': 'Get Date Time',
            'elements': [
                {
                    'name': 'Date',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        6: {
            'function_id': 6,
            'name': 'Restart',
            'elements': [
                {
                    'name': 'Restart Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Set Coordinates Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Coordinates Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Status Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Status Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        11: {
            'function_id': 11,
            'name': 'Set Altitude Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Altitude Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Set Motion Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Motion Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        15: {
            'function_id': 15,
            'name': 'Set Date Time Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Date Time Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        17: {
            'function_id': 17,
            'name': 'Coordinates',
            'elements': [
                {
                    'name': 'Latitude',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'NS',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Longitude',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'EW',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'PDOP',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'HDOP',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'VDOP',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'EPE',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I c I c H H H H',
        },
        18: {
            'function_id': 18,
            'name': 'Status',
            'elements': [
                {
                    'name': 'Fix',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Satellites View',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Satellites Used',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        19: {
            'function_id': 19,
            'name': 'Altitude',
            'elements': [
                {
                    'name': 'Altitude',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Geoidal Separation',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i',
        },
        20: {
            'function_id': 20,
            'name': 'Motion',
            'elements': [
                {
                    'name': 'Course',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        21: {
            'function_id': 21,
            'name': 'Date Time',
            'elements': [
                {
                    'name': 'Date',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
276: {
    'device_identifier': 276,
    'name': 'GPS Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Coordinates',
            'elements': [
                {
                    'name': 'Latitude',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'NS',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Longitude',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'EW',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I c I c',
        },
        2: {
            'function_id': 2,
            'name': 'Get Status',
            'elements': [
                {
                    'name': 'Has Fix',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Satellites View',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! B',
        },
        3: {
            'function_id': 3,
            'name': 'Get Altitude',
            'elements': [
                {
                    'name': 'Altitude',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Geoidal Separation',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i',
        },
        4: {
            'function_id': 4,
            'name': 'Get Motion',
            'elements': [
                {
                    'name': 'Course',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        5: {
            'function_id': 5,
            'name': 'Get Date Time',
            'elements': [
                {
                    'name': 'Date',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        6: {
            'function_id': 6,
            'name': 'Restart',
            'elements': [
                {
                    'name': 'Restart Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Satellite System Status Low Level',
            'elements': [
                {
                    'name': 'Satellite System',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Satellite Numbers Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Satellite Numbers Data',
                    'type': 'uint8',
                    'cardinality': '12',
                    'direction': 'out'
                },
                {
                    'name': 'Fix',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'PDOP',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'HDOP',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'VDOP',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B 12B B H H H',
        },
        8: {
            'function_id': 8,
            'name': 'Get Satellite Status',
            'elements': [
                {
                    'name': 'Satellite System',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Satellite Number',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Elevation',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Azimuth',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'SNR',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': 'h h h',
        },
        9: {
            'function_id': 9,
            'name': 'Set Fix LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Fix LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        11: {
            'function_id': 11,
            'name': 'Set Coordinates Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Coordinates Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Set Status Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Status Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        15: {
            'function_id': 15,
            'name': 'Set Altitude Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Altitude Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        17: {
            'function_id': 17,
            'name': 'Set Motion Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Motion Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        19: {
            'function_id': 19,
            'name': 'Set Date Time Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Get Date Time Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        21: {
            'function_id': 21,
            'name': 'Pulse Per Second',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        22: {
            'function_id': 22,
            'name': 'Coordinates',
            'elements': [
                {
                    'name': 'Latitude',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'NS',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Longitude',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'EW',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I c I c',
        },
        23: {
            'function_id': 23,
            'name': 'Status',
            'elements': [
                {
                    'name': 'Has Fix',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Satellites View',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! B',
        },
        24: {
            'function_id': 24,
            'name': 'Altitude',
            'elements': [
                {
                    'name': 'Altitude',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Geoidal Separation',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i i',
        },
        25: {
            'function_id': 25,
            'name': 'Motion',
            'elements': [
                {
                    'name': 'Course',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        26: {
            'function_id': 26,
            'name': 'Date Time',
            'elements': [
                {
                    'name': 'Date',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        27: {
            'function_id': 27,
            'name': 'Set SBAS Config',
            'elements': [
                {
                    'name': 'SBAS Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        28: {
            'function_id': 28,
            'name': 'Get SBAS Config',
            'elements': [
                {
                    'name': 'SBAS Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
240: {
    'device_identifier': 240,
    'name': 'Hall Effect Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        2: {
            'function_id': 2,
            'name': 'Get Edge Count',
            'elements': [
                {
                    'name': 'Reset Counter',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': 'I',
        },
        3: {
            'function_id': 3,
            'name': 'Set Edge Count Config',
            'elements': [
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Edge Count Config',
            'elements': [
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        5: {
            'function_id': 5,
            'name': 'Set Edge Interrupt',
            'elements': [
                {
                    'name': 'Edges',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Edge Interrupt',
            'elements': [
                {
                    'name': 'Edges',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Edge Count Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Edge Count Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Edge Interrupt',
            'elements': [
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        10: {
            'function_id': 10,
            'name': 'Edge Count',
            'elements': [
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2132: {
    'device_identifier': 2132,
    'name': 'Hall Effect Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Magnetic Flux Density',
            'elements': [
                {
                    'name': 'Magnetic Flux Density',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Set Magnetic Flux Density Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Magnetic Flux Density Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        4: {
            'function_id': 4,
            'name': 'Magnetic Flux Density',
            'elements': [
                {
                    'name': 'Magnetic Flux Density',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        5: {
            'function_id': 5,
            'name': 'Get Counter',
            'elements': [
                {
                    'name': 'Reset Counter',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': 'I',
        },
        6: {
            'function_id': 6,
            'name': 'Set Counter Config',
            'elements': [
                {
                    'name': 'High Threshold',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Low Threshold',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'h h I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Counter Config',
            'elements': [
                {
                    'name': 'High Threshold',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Low Threshold',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h I',
        },
        8: {
            'function_id': 8,
            'name': 'Set Counter Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Counter Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        10: {
            'function_id': 10,
            'name': 'Counter',
            'elements': [
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
27: {
    'device_identifier': 27,
    'name': 'Humidity Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Humidity',
            'elements': [
                {
                    'name': 'Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Humidity Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Humidity Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Humidity Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Humidity Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Humidity',
            'elements': [
                {
                    'name': 'Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        14: {
            'function_id': 14,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        15: {
            'function_id': 15,
            'name': 'Humidity Reached',
            'elements': [
                {
                    'name': 'Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
283: {
    'device_identifier': 283,
    'name': 'Humidity Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Humidity',
            'elements': [
                {
                    'name': 'Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Humidity Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Humidity Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        4: {
            'function_id': 4,
            'name': 'Humidity',
            'elements': [
                {
                    'name': 'Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        6: {
            'function_id': 6,
            'name': 'Set Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        8: {
            'function_id': 8,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        9: {
            'function_id': 9,
            'name': 'Set Heater Configuration',
            'elements': [
                {
                    'name': 'Heater Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Heater Configuration',
            'elements': [
                {
                    'name': 'Heater Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        11: {
            'function_id': 11,
            'name': 'Set Moving Average Configuration',
            'elements': [
                {
                    'name': 'Moving Average Length Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Moving Average Length Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Moving Average Configuration',
            'elements': [
                {
                    'name': 'Moving Average Length Humidity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Moving Average Length Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        13: {
            'function_id': 13,
            'name': 'Set Samples Per Second',
            'elements': [
                {
                    'name': 'SPS',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Samples Per Second',
            'elements': [
                {
                    'name': 'SPS',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
258: {
    'device_identifier': 258,
    'name': 'Industrial Analog Out Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Enable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Disable',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Is Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        4: {
            'function_id': 4,
            'name': 'Set Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        8: {
            'function_id': 8,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Voltage Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Voltage Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2116: {
    'device_identifier': 2116,
    'name': 'Industrial Analog Out Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        3: {
            'function_id': 3,
            'name': 'Set Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Set Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        7: {
            'function_id': 7,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Voltage Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Voltage Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Range',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        9: {
            'function_id': 9,
            'name': 'Set Out LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Out LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        11: {
            'function_id': 11,
            'name': 'Set Out LED Status Config',
            'elements': [
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Out LED Status Config',
            'elements': [
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
293: {
    'device_identifier': 293,
    'name': 'Industrial Counter Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Counter',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Counter',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'q',
        },
        2: {
            'function_id': 2,
            'name': 'Get All Counter',
            'elements': [
                {
                    'name': 'Counter',
                    'type': 'int64',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4q',
        },
        3: {
            'function_id': 3,
            'name': 'Set Counter',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Counter',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B q',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set All Counter',
            'elements': [
                {
                    'name': 'Counter',
                    'type': 'int64',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4q',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Signal Data',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Duty Cycle',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Period',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H Q I !',
        },
        6: {
            'function_id': 6,
            'name': 'Get All Signal Data',
            'elements': [
                {
                    'name': 'Duty Cycle',
                    'type': 'uint16',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Period',
                    'type': 'uint64',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4H 4Q 4I 4!',
        },
        7: {
            'function_id': 7,
            'name': 'Set Counter Active',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Active',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Set All Counter Active',
            'elements': [
                {
                    'name': 'Active',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4!',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Counter Active',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Active',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '!',
        },
        10: {
            'function_id': 10,
            'name': 'Get All Counter Active',
            'elements': [
                {
                    'name': 'Active',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4!',
        },
        11: {
            'function_id': 11,
            'name': 'Set Counter Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count Edge',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count Direction',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Duty Cycle Prescaler',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frequency Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Counter Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count Edge',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Count Direction',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duty Cycle Prescaler',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frequency Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B B B B',
        },
        13: {
            'function_id': 13,
            'name': 'Set All Counter Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get All Counter Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        15: {
            'function_id': 15,
            'name': 'Set All Signal Data Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get All Signal Data Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        17: {
            'function_id': 17,
            'name': 'Set Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        19: {
            'function_id': 19,
            'name': 'All Counter',
            'elements': [
                {
                    'name': 'Counter',
                    'type': 'int64',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4q',
        },
        20: {
            'function_id': 20,
            'name': 'All Signal Data',
            'elements': [
                {
                    'name': 'Duty Cycle',
                    'type': 'uint16',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Period',
                    'type': 'uint64',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4H 4Q 4I 4!',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
223: {
    'device_identifier': 223,
    'name': 'Industrial Digital In 4 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Group',
            'elements': [
                {
                    'name': 'Group',
                    'type': 'char',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4c',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Group',
            'elements': [
                {
                    'name': 'Group',
                    'type': 'char',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4c',
        },
        4: {
            'function_id': 4,
            'name': 'Get Available For Group',
            'elements': [
                {
                    'name': 'Available',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        5: {
            'function_id': 5,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Interrupt',
            'elements': [
                {
                    'name': 'Interrupt Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Interrupt',
            'elements': [
                {
                    'name': 'Interrupt Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        9: {
            'function_id': 9,
            'name': 'Interrupt',
            'elements': [
                {
                    'name': 'Interrupt Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        10: {
            'function_id': 10,
            'name': 'Get Edge Count',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Reset Counter',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': 'I',
        },
        11: {
            'function_id': 11,
            'name': 'Set Edge Count Config',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Edge Count Config',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2100: {
    'device_identifier': 2100,
    'name': 'Industrial Digital In 4 Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4!',
        },
        2: {
            'function_id': 2,
            'name': 'Set Value Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I !',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Value Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I !',
        },
        4: {
            'function_id': 4,
            'name': 'Set All Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get All Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        6: {
            'function_id': 6,
            'name': 'Get Edge Count',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Reset Counter',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Edge Count Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Edge Count Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B B',
        },
        9: {
            'function_id': 9,
            'name': 'Set Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        11: {
            'function_id': 11,
            'name': 'Value',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Changed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B ! !',
        },
        12: {
            'function_id': 12,
            'name': 'All Value',
            'elements': [
                {
                    'name': 'Changed',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4! 4!',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
224: {
    'device_identifier': 224,
    'name': 'Industrial Digital Out 4 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Value',
            'elements': [
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H I I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Group',
            'elements': [
                {
                    'name': 'Group',
                    'type': 'char',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4c',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Group',
            'elements': [
                {
                    'name': 'Group',
                    'type': 'char',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4c',
        },
        7: {
            'function_id': 7,
            'name': 'Get Available For Group',
            'elements': [
                {
                    'name': 'Available',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        8: {
            'function_id': 8,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Selected Values',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2124: {
    'device_identifier': 2124,
    'name': 'Industrial Digital Out 4 Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4!',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4!',
        },
        3: {
            'function_id': 3,
            'name': 'Set Selected Value',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! I',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! I I',
        },
        6: {
            'function_id': 6,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        7: {
            'function_id': 7,
            'name': 'Set Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        9: {
            'function_id': 9,
            'name': 'Set PWM Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Duty Cycle',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get PWM Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duty Cycle',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
228: {
    'device_identifier': 228,
    'name': 'Industrial Dual 0-20mA Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Current',
            'elements': [
                {
                    'name': 'Sensor',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Current Callback Period',
            'elements': [
                {
                    'name': 'Sensor',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Current Callback Period',
            'elements': [
                {
                    'name': 'Sensor',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Current Callback Threshold',
            'elements': [
                {
                    'name': 'Sensor',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B c i i',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Current Callback Threshold',
            'elements': [
                {
                    'name': 'Sensor',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'c i i',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Set Sample Rate',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Sample Rate',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        10: {
            'function_id': 10,
            'name': 'Current',
            'elements': [
                {
                    'name': 'Sensor',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B i',
        },
        11: {
            'function_id': 11,
            'name': 'Current Reached',
            'elements': [
                {
                    'name': 'Sensor',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B i',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2120: {
    'device_identifier': 2120,
    'name': 'Industrial Dual 0-20mA Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Current',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Current Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I ! c i i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Current Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I ! c i i',
        },
        4: {
            'function_id': 4,
            'name': 'Current',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B i',
        },
        5: {
            'function_id': 5,
            'name': 'Set Sample Rate',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Sample Rate',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        7: {
            'function_id': 7,
            'name': 'Set Gain',
            'elements': [
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Gain',
            'elements': [
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        9: {
            'function_id': 9,
            'name': 'Set Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        11: {
            'function_id': 11,
            'name': 'Set Channel LED Status Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B i i B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Channel LED Status Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'i i B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
249: {
    'device_identifier': 249,
    'name': 'Industrial Dual Analog In Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Voltage Callback Period',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Voltage Callback Period',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B c i i',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'c i i',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Set Sample Rate',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Sample Rate',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        10: {
            'function_id': 10,
            'name': 'Set Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'in'
                },
                {
                    'name': 'Gain',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '2i 2i',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'out'
                },
                {
                    'name': 'Gain',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '2i 2i',
        },
        12: {
            'function_id': 12,
            'name': 'Get ADC Values',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '2i',
        },
        13: {
            'function_id': 13,
            'name': 'Voltage',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B i',
        },
        14: {
            'function_id': 14,
            'name': 'Voltage Reached',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B i',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2121: {
    'device_identifier': 2121,
    'name': 'Industrial Dual Analog In Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Voltage Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I ! c i i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Voltage Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I ! c i i',
        },
        4: {
            'function_id': 4,
            'name': 'Voltage',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B i',
        },
        5: {
            'function_id': 5,
            'name': 'Set Sample Rate',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Sample Rate',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        7: {
            'function_id': 7,
            'name': 'Set Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'in'
                },
                {
                    'name': 'Gain',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '2i 2i',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'out'
                },
                {
                    'name': 'Gain',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '2i 2i',
        },
        9: {
            'function_id': 9,
            'name': 'Get ADC Values',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '2i',
        },
        10: {
            'function_id': 10,
            'name': 'Set Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        12: {
            'function_id': 12,
            'name': 'Set Channel LED Status Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B i i B',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Channel LED Status Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'i i B',
        },
        14: {
            'function_id': 14,
            'name': 'Get All Voltages',
            'elements': [
                {
                    'name': 'Voltages',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '2i',
        },
        15: {
            'function_id': 15,
            'name': 'Set All Voltages Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get All Voltages Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        17: {
            'function_id': 17,
            'name': 'All Voltages',
            'elements': [
                {
                    'name': 'Voltages',
                    'type': 'int32',
                    'cardinality': '2',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '2i',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
284: {
    'device_identifier': 284,
    'name': 'Industrial Dual Relay Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Value',
            'elements': [
                {
                    'name': 'Channel0',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Channel1',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! !',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Channel0',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Channel1',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! !',
        },
        3: {
            'function_id': 3,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! I I',
        },
        5: {
            'function_id': 5,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        6: {
            'function_id': 6,
            'name': 'Set Selected Value',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
225: {
    'device_identifier': 225,
    'name': 'Industrial Quad Relay Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Value',
            'elements': [
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H I I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Group',
            'elements': [
                {
                    'name': 'Group',
                    'type': 'char',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4c',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Group',
            'elements': [
                {
                    'name': 'Group',
                    'type': 'char',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4c',
        },
        7: {
            'function_id': 7,
            'name': 'Get Available For Group',
            'elements': [
                {
                    'name': 'Available',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        8: {
            'function_id': 8,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Selected Values',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2102: {
    'device_identifier': 2102,
    'name': 'Industrial Quad Relay Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4!',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4!',
        },
        3: {
            'function_id': 3,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! I I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Selected Value',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Set Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Channel LED Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        8: {
            'function_id': 8,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
28: {
    'device_identifier': 28,
    'name': 'IO-16 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Port',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Port',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B',
        },
        3: {
            'function_id': 3,
            'name': 'Set Port Configuration',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Selection Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Direction',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B c !',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Port Configuration',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Direction Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B B',
        },
        5: {
            'function_id': 5,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Port Interrupt',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Interrupt Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Port Interrupt',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Interrupt Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c',
            'out_struct_format': 'B',
        },
        9: {
            'function_id': 9,
            'name': 'Interrupt',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Interrupt Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c B B',
        },
        10: {
            'function_id': 10,
            'name': 'Set Port Monoflop',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Selection Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B B I',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Port Monoflop',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'c B',
            'out_struct_format': 'B I I',
        },
        12: {
            'function_id': 12,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Selection Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c B B',
        },
        13: {
            'function_id': 13,
            'name': 'Set Selected Values',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Selection Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Edge Count',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Reset Counter',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': 'I',
        },
        15: {
            'function_id': 15,
            'name': 'Set Edge Count Config',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Edge Count Config',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2114: {
    'device_identifier': 2114,
    'name': 'IO-16 Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '16',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '16!',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '16',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '16!',
        },
        3: {
            'function_id': 3,
            'name': 'Set Selected Value',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Direction',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B c !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Direction',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'c !',
        },
        6: {
            'function_id': 6,
            'name': 'Set Input Value Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I !',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Input Value Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I !',
        },
        8: {
            'function_id': 8,
            'name': 'Set All Input Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get All Input Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        10: {
            'function_id': 10,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! I',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! I I',
        },
        12: {
            'function_id': 12,
            'name': 'Get Edge Count',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Reset Counter',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Set Edge Count Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Edge Count Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B B',
        },
        15: {
            'function_id': 15,
            'name': 'Input Value',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Changed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B ! !',
        },
        16: {
            'function_id': 16,
            'name': 'All Input Value',
            'elements': [
                {
                    'name': 'Changed',
                    'type': 'bool',
                    'cardinality': '16',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '16',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '16! 16!',
        },
        17: {
            'function_id': 17,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
29: {
    'device_identifier': 29,
    'name': 'IO-4 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Value',
            'elements': [
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        3: {
            'function_id': 3,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Direction',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B c !',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Direction Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        5: {
            'function_id': 5,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Interrupt',
            'elements': [
                {
                    'name': 'Interrupt Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Interrupt',
            'elements': [
                {
                    'name': 'Interrupt Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        9: {
            'function_id': 9,
            'name': 'Interrupt',
            'elements': [
                {
                    'name': 'Interrupt Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        10: {
            'function_id': 10,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B I',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B I I',
        },
        12: {
            'function_id': 12,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        13: {
            'function_id': 13,
            'name': 'Set Selected Values',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Edge Count',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Reset Counter',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': 'I',
        },
        15: {
            'function_id': 15,
            'name': 'Set Edge Count Config',
            'elements': [
                {
                    'name': 'Selection Mask',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Edge Count Config',
            'elements': [
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2111: {
    'device_identifier': 2111,
    'name': 'IO-4 Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4!',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4!',
        },
        3: {
            'function_id': 3,
            'name': 'Set Selected Value',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Direction',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B c !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Direction',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'c !',
        },
        6: {
            'function_id': 6,
            'name': 'Set Input Value Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I !',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Input Value Callback Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I !',
        },
        8: {
            'function_id': 8,
            'name': 'Set All Input Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get All Input Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        10: {
            'function_id': 10,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! I',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! I I',
        },
        12: {
            'function_id': 12,
            'name': 'Get Edge Count',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Reset Counter',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Set Edge Count Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Edge Count Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Edge Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Debounce',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B B',
        },
        15: {
            'function_id': 15,
            'name': 'Set PWM Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Duty Cycle',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I H',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get PWM Configuration',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duty Cycle',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'I H',
        },
        17: {
            'function_id': 17,
            'name': 'Input Value',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Changed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B ! !',
        },
        18: {
            'function_id': 18,
            'name': 'All Input Value',
            'elements': [
                {
                    'name': 'Changed',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4! 4!',
        },
        19: {
            'function_id': 19,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2122: {
    'device_identifier': 2122,
    'name': 'Isolator Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Statistics',
            'elements': [
                {
                    'name': 'Messages From Brick',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Messages From Bricklet',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Bricklet Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Bricklet UID',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I H 8s',
        },
        2: {
            'function_id': 2,
            'name': 'Set SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get SPITFP Baudrate Config',
            'elements': [
                {
                    'name': 'Enable Dynamic Baudrate',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Dynamic Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I',
        },
        4: {
            'function_id': 4,
            'name': 'Set SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get SPITFP Baudrate',
            'elements': [
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        6: {
            'function_id': 6,
            'name': 'Get Isolator SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count ACK Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Statistics Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Statistics Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        9: {
            'function_id': 9,
            'name': 'Statistics',
            'elements': [
                {
                    'name': 'Messages From Brick',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Messages From Bricklet',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Bricklet Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Bricklet UID',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I H 8s',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
210: {
    'device_identifier': 210,
    'name': 'Joystick Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Position',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h',
        },
        2: {
            'function_id': 2,
            'name': 'Is Pressed',
            'elements': [
                {
                    'name': 'Pressed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        3: {
            'function_id': 3,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        4: {
            'function_id': 4,
            'name': 'Calibrate',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Set Position Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Position Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Position Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c h h h h',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Position Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c h h h h',
        },
        11: {
            'function_id': 11,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min Y',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max Y',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H H H',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min Y',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max Y',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H H H',
        },
        13: {
            'function_id': 13,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        15: {
            'function_id': 15,
            'name': 'Position',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        17: {
            'function_id': 17,
            'name': 'Position Reached',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h',
        },
        18: {
            'function_id': 18,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        19: {
            'function_id': 19,
            'name': 'Pressed',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Released',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2138: {
    'device_identifier': 2138,
    'name': 'Joystick Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Position',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h',
        },
        2: {
            'function_id': 2,
            'name': 'Is Pressed',
            'elements': [
                {
                    'name': 'Pressed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        3: {
            'function_id': 3,
            'name': 'Calibrate',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        6: {
            'function_id': 6,
            'name': 'Position',
            'elements': [
                {
                    'name': 'X',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h h',
        },
        7: {
            'function_id': 7,
            'name': 'Set Pressed Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Pressed Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        9: {
            'function_id': 9,
            'name': 'Pressed',
            'elements': [
                {
                    'name': 'Pressed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
255: {
    'device_identifier': 255,
    'name': 'Laser Range Finder Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        3: {
            'function_id': 3,
            'name': 'Set Distance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Distance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Velocity Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Velocity Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Distance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Distance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Velocity Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c h h',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Velocity Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c h h',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Set Moving Average',
            'elements': [
                {
                    'name': 'Distance Average Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Velocity Average Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Moving Average',
            'elements': [
                {
                    'name': 'Distance Average Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Velocity Average Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        15: {
            'function_id': 15,
            'name': 'Set Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        17: {
            'function_id': 17,
            'name': 'Enable Laser',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Disable Laser',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        19: {
            'function_id': 19,
            'name': 'Is Laser Enabled',
            'elements': [
                {
                    'name': 'Laser Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        20: {
            'function_id': 20,
            'name': 'Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        21: {
            'function_id': 21,
            'name': 'Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        22: {
            'function_id': 22,
            'name': 'Distance Reached',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        23: {
            'function_id': 23,
            'name': 'Velocity Reached',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        24: {
            'function_id': 24,
            'name': 'Get Sensor Hardware Version',
            'elements': [
                {
                    'name': 'Version',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        25: {
            'function_id': 25,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Acquisition Count',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enable Quick Termination',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Threshold Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Measurement Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! B H',
            'out_struct_format': '',
        },
        26: {
            'function_id': 26,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Acquisition Count',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enable Quick Termination',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Threshold Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Measurement Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B ! B H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2144: {
    'device_identifier': 2144,
    'name': 'Laser Range Finder Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Set Distance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Distance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        4: {
            'function_id': 4,
            'name': 'Distance',
            'elements': [
                {
                    'name': 'Distance',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        5: {
            'function_id': 5,
            'name': 'Get Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        6: {
            'function_id': 6,
            'name': 'Set Velocity Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Velocity Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        8: {
            'function_id': 8,
            'name': 'Velocity',
            'elements': [
                {
                    'name': 'Velocity',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        9: {
            'function_id': 9,
            'name': 'Set Enable',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Enable',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        11: {
            'function_id': 11,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Acquisition Count',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enable Quick Termination',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Threshold Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Measurement Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! B H',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Acquisition Count',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enable Quick Termination',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Threshold Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Measurement Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B ! B H',
        },
        13: {
            'function_id': 13,
            'name': 'Set Moving Average',
            'elements': [
                {
                    'name': 'Distance Average Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Velocity Average Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Moving Average',
            'elements': [
                {
                    'name': 'Distance Average Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Velocity Average Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        15: {
            'function_id': 15,
            'name': 'Set Offset Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'h',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Offset Calibration',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        17: {
            'function_id': 17,
            'name': 'Set Distance LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Distance LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
298: {
    'device_identifier': 298,
    'name': 'LCD 128x64 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write Pixels Low Level',
            'elements': [
                {
                    'name': 'X Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'X End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Chunk Data',
                    'type': 'bool',
                    'cardinality': '448',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B H H 448!',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Read Pixels Low Level',
            'elements': [
                {
                    'name': 'X Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'X End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pixels Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pixels Chunk Data',
                    'type': 'bool',
                    'cardinality': '480',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B B B B',
            'out_struct_format': 'H H 480!',
        },
        3: {
            'function_id': 3,
            'name': 'Clear Display',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Display Configuration',
            'elements': [
                {
                    'name': 'Contrast',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Backlight',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Invert',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Automatic Draw',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B ! !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Display Configuration',
            'elements': [
                {
                    'name': 'Contrast',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Backlight',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Invert',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Automatic Draw',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B ! !',
        },
        6: {
            'function_id': 6,
            'name': 'Write Line',
            'elements': [
                {
                    'name': 'Line',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '22',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B 22s',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Draw Buffered Frame',
            'elements': [
                {
                    'name': 'Force Complete Redraw',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Touch Position',
            'elements': [
                {
                    'name': 'Pressure',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Age',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Touch Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Touch Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        11: {
            'function_id': 11,
            'name': 'Touch Position',
            'elements': [
                {
                    'name': 'Pressure',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'X',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Age',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H I',
        },
        12: {
            'function_id': 12,
            'name': 'Get Touch Gesture',
            'elements': [
                {
                    'name': 'Gesture',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pressure Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'X Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'X End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Age',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I H H H H H I',
        },
        13: {
            'function_id': 13,
            'name': 'Set Touch Gesture Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Touch Gesture Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        15: {
            'function_id': 15,
            'name': 'Touch Gesture',
            'elements': [
                {
                    'name': 'Gesture',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pressure Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'X Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'X End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Y End',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Age',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I H H H H H I',
        },
        16: {
            'function_id': 16,
            'name': 'Draw Line',
            'elements': [
                {
                    'name': 'Position X Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position X End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Color',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B !',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Draw Box',
            'elements': [
                {
                    'name': 'Position X Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position X End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Fill',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Color',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B ! !',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Draw Text',
            'elements': [
                {
                    'name': 'Position X',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Font',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Color',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '22',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B ! 22s',
            'out_struct_format': '',
        },
        19: {
            'function_id': 19,
            'name': 'Set GUI Button',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position X',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Width',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Height',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '16',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B B 16s',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Get GUI Button',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Active',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position X',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position Y',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Width',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Height',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '16',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! B B B B 16s',
        },
        21: {
            'function_id': 21,
            'name': 'Remove GUI Button',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        22: {
            'function_id': 22,
            'name': 'Set GUI Button Pressed Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        23: {
            'function_id': 23,
            'name': 'Get GUI Button Pressed Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        24: {
            'function_id': 24,
            'name': 'Get GUI Button Pressed',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pressed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '!',
        },
        25: {
            'function_id': 25,
            'name': 'GUI Button Pressed',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pressed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        26: {
            'function_id': 26,
            'name': 'Set GUI Slider',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position X',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Direction',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B B B',
            'out_struct_format': '',
        },
        27: {
            'function_id': 27,
            'name': 'Get GUI Slider',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Active',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position X',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position Y',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Direction',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! B B B B B',
        },
        28: {
            'function_id': 28,
            'name': 'Remove GUI Slider',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        29: {
            'function_id': 29,
            'name': 'Set GUI Slider Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        30: {
            'function_id': 30,
            'name': 'Get GUI Slider Value Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        31: {
            'function_id': 31,
            'name': 'Get GUI Slider Value',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        32: {
            'function_id': 32,
            'name': 'GUI Slider Value',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        33: {
            'function_id': 33,
            'name': 'Set GUI Tab Configuration',
            'elements': [
                {
                    'name': 'Change Tab Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Clear GUI',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        34: {
            'function_id': 34,
            'name': 'Get GUI Tab Configuration',
            'elements': [
                {
                    'name': 'Change Tab Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Clear GUI',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        35: {
            'function_id': 35,
            'name': 'Set GUI Tab Text',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '5',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B 5s',
            'out_struct_format': '',
        },
        36: {
            'function_id': 36,
            'name': 'Get GUI Tab Text',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Active',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '5',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! 5s',
        },
        37: {
            'function_id': 37,
            'name': 'Set GUI Tab Icon',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Icon',
                    'type': 'bool',
                    'cardinality': '168',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B 168!',
            'out_struct_format': '',
        },
        38: {
            'function_id': 38,
            'name': 'Get GUI Tab Icon',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Active',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Icon',
                    'type': 'bool',
                    'cardinality': '168',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! 168!',
        },
        39: {
            'function_id': 39,
            'name': 'Remove GUI Tab',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        40: {
            'function_id': 40,
            'name': 'Set GUI Tab Selected',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        41: {
            'function_id': 41,
            'name': 'Set GUI Tab Selected Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        42: {
            'function_id': 42,
            'name': 'Get GUI Tab Selected Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        43: {
            'function_id': 43,
            'name': 'Get GUI Tab Selected',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'b',
        },
        44: {
            'function_id': 44,
            'name': 'GUI Tab Selected',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'b',
        },
        45: {
            'function_id': 45,
            'name': 'Set GUI Graph Configuration',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Graph Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position X',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position Y',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Width',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Height',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text X',
                    'type': 'string',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Text Y',
                    'type': 'string',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B B B 4s 4s',
            'out_struct_format': '',
        },
        46: {
            'function_id': 46,
            'name': 'Get GUI Graph Configuration',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Active',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Graph Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position X',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position Y',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Width',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Height',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Text X',
                    'type': 'string',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Text Y',
                    'type': 'string',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '! B B B B B 4s 4s',
        },
        47: {
            'function_id': 47,
            'name': 'Set GUI Graph Data Low Level',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data Chunk Data',
                    'type': 'uint8',
                    'cardinality': '59',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H H 59B',
            'out_struct_format': '',
        },
        48: {
            'function_id': 48,
            'name': 'Get GUI Graph Data Low Level',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data Chunk Data',
                    'type': 'uint8',
                    'cardinality': '59',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H H 59B',
        },
        49: {
            'function_id': 49,
            'name': 'Remove GUI Graph',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        50: {
            'function_id': 50,
            'name': 'Remove All GUI',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        51: {
            'function_id': 51,
            'name': 'Set Touch LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        52: {
            'function_id': 52,
            'name': 'Get Touch LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
211: {
    'device_identifier': 211,
    'name': 'LCD 16x2 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write Line',
            'elements': [
                {
                    'name': 'Line',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '16',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B 16s',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Clear Display',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Backlight On',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Backlight Off',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Is Backlight On',
            'elements': [
                {
                    'name': 'Backlight',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        6: {
            'function_id': 6,
            'name': 'Set Config',
            'elements': [
                {
                    'name': 'Cursor',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Blinking',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! !',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Config',
            'elements': [
                {
                    'name': 'Cursor',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Blinking',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! !',
        },
        8: {
            'function_id': 8,
            'name': 'Is Button Pressed',
            'elements': [
                {
                    'name': 'Button',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pressed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '!',
        },
        9: {
            'function_id': 9,
            'name': 'Button Pressed',
            'elements': [
                {
                    'name': 'Button',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        10: {
            'function_id': 10,
            'name': 'Button Released',
            'elements': [
                {
                    'name': 'Button',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        11: {
            'function_id': 11,
            'name': 'Set Custom Character',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Character',
                    'type': 'uint8',
                    'cardinality': '8',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B 8B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Custom Character',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Character',
                    'type': 'uint8',
                    'cardinality': '8',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '8B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
212: {
    'device_identifier': 212,
    'name': 'LCD 20x4 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write Line',
            'elements': [
                {
                    'name': 'Line',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '20',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B 20s',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Clear Display',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Backlight On',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Backlight Off',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Is Backlight On',
            'elements': [
                {
                    'name': 'Backlight',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        6: {
            'function_id': 6,
            'name': 'Set Config',
            'elements': [
                {
                    'name': 'Cursor',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Blinking',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! !',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Config',
            'elements': [
                {
                    'name': 'Cursor',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Blinking',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! !',
        },
        8: {
            'function_id': 8,
            'name': 'Is Button Pressed',
            'elements': [
                {
                    'name': 'Button',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pressed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '!',
        },
        9: {
            'function_id': 9,
            'name': 'Button Pressed',
            'elements': [
                {
                    'name': 'Button',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        10: {
            'function_id': 10,
            'name': 'Button Released',
            'elements': [
                {
                    'name': 'Button',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        11: {
            'function_id': 11,
            'name': 'Set Custom Character',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Character',
                    'type': 'uint8',
                    'cardinality': '8',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B 8B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Custom Character',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Character',
                    'type': 'uint8',
                    'cardinality': '8',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '8B',
        },
        13: {
            'function_id': 13,
            'name': 'Set Default Text',
            'elements': [
                {
                    'name': 'Line',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '20',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B 20s',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Default Text',
            'elements': [
                {
                    'name': 'Line',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '20',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '20s',
        },
        15: {
            'function_id': 15,
            'name': 'Set Default Text Counter',
            'elements': [
                {
                    'name': 'Counter',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'i',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Default Text Counter',
            'elements': [
                {
                    'name': 'Counter',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
231: {
    'device_identifier': 231,
    'name': 'LED Strip Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set RGB Values',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'R',
                    'type': 'uint8',
                    'cardinality': '16',
                    'direction': 'in'
                },
                {
                    'name': 'G',
                    'type': 'uint8',
                    'cardinality': '16',
                    'direction': 'in'
                },
                {
                    'name': 'B',
                    'type': 'uint8',
                    'cardinality': '16',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B 16B 16B 16B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get RGB Values',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'R',
                    'type': 'uint8',
                    'cardinality': '16',
                    'direction': 'out'
                },
                {
                    'name': 'G',
                    'type': 'uint8',
                    'cardinality': '16',
                    'direction': 'out'
                },
                {
                    'name': 'B',
                    'type': 'uint8',
                    'cardinality': '16',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H B',
            'out_struct_format': '16B 16B 16B',
        },
        3: {
            'function_id': 3,
            'name': 'Set Frame Duration',
            'elements': [
                {
                    'name': 'Duration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Frame Duration',
            'elements': [
                {
                    'name': 'Duration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Get Supply Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        6: {
            'function_id': 6,
            'name': 'Frame Rendered',
            'elements': [
                {
                    'name': 'Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        7: {
            'function_id': 7,
            'name': 'Set Clock Frequency',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Clock Frequency',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Chip Type',
            'elements': [
                {
                    'name': 'Chip',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Chip Type',
            'elements': [
                {
                    'name': 'Chip',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        11: {
            'function_id': 11,
            'name': 'Set RGBW Values',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'R',
                    'type': 'uint8',
                    'cardinality': '12',
                    'direction': 'in'
                },
                {
                    'name': 'G',
                    'type': 'uint8',
                    'cardinality': '12',
                    'direction': 'in'
                },
                {
                    'name': 'B',
                    'type': 'uint8',
                    'cardinality': '12',
                    'direction': 'in'
                },
                {
                    'name': 'W',
                    'type': 'uint8',
                    'cardinality': '12',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B 12B 12B 12B 12B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get RGBW Values',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'R',
                    'type': 'uint8',
                    'cardinality': '12',
                    'direction': 'out'
                },
                {
                    'name': 'G',
                    'type': 'uint8',
                    'cardinality': '12',
                    'direction': 'out'
                },
                {
                    'name': 'B',
                    'type': 'uint8',
                    'cardinality': '12',
                    'direction': 'out'
                },
                {
                    'name': 'W',
                    'type': 'uint8',
                    'cardinality': '12',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H B',
            'out_struct_format': '12B 12B 12B 12B',
        },
        13: {
            'function_id': 13,
            'name': 'Set Channel Mapping',
            'elements': [
                {
                    'name': 'Mapping',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Channel Mapping',
            'elements': [
                {
                    'name': 'Mapping',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        15: {
            'function_id': 15,
            'name': 'Enable Frame Rendered Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Disable Frame Rendered Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Is Frame Rendered Callback Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2103: {
    'device_identifier': 2103,
    'name': 'LED Strip Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set LED Values Low Level',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Chunk Data',
                    'type': 'uint8',
                    'cardinality': '58',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H H 58B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get LED Values Low Level',
            'elements': [
                {
                    'name': 'Index',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': 'H H 60B',
        },
        3: {
            'function_id': 3,
            'name': 'Set Frame Duration',
            'elements': [
                {
                    'name': 'Duration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Frame Duration',
            'elements': [
                {
                    'name': 'Duration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Get Supply Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        6: {
            'function_id': 6,
            'name': 'Frame Started',
            'elements': [
                {
                    'name': 'Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        7: {
            'function_id': 7,
            'name': 'Set Clock Frequency',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Clock Frequency',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Chip Type',
            'elements': [
                {
                    'name': 'Chip',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Chip Type',
            'elements': [
                {
                    'name': 'Chip',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Channel Mapping',
            'elements': [
                {
                    'name': 'Mapping',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Channel Mapping',
            'elements': [
                {
                    'name': 'Mapping',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        13: {
            'function_id': 13,
            'name': 'Set Frame Started Callback Configuration',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Frame Started Callback Configuration',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
241: {
    'device_identifier': 241,
    'name': 'Line Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Reflectivity',
            'elements': [
                {
                    'name': 'Reflectivity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Reflectivity Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Reflectivity Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Reflectivity Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Reflectivity Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Reflectivity',
            'elements': [
                {
                    'name': 'Reflectivity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        9: {
            'function_id': 9,
            'name': 'Reflectivity Reached',
            'elements': [
                {
                    'name': 'Reflectivity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
213: {
    'device_identifier': 213,
    'name': 'Linear Poti Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Position Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Position Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Position Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Position Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        14: {
            'function_id': 14,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        15: {
            'function_id': 15,
            'name': 'Position Reached',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2139: {
    'device_identifier': 2139,
    'name': 'Linear Poti Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        2: {
            'function_id': 2,
            'name': 'Set Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c B B',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c B B',
        },
        4: {
            'function_id': 4,
            'name': 'Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
253: {
    'device_identifier': 253,
    'name': 'Load Cell Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Weight',
            'elements': [
                {
                    'name': 'Weight',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Weight Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Weight Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Weight Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Weight Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Set Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        10: {
            'function_id': 10,
            'name': 'LED On',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'LED Off',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Is LED On',
            'elements': [
                {
                    'name': 'On',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        13: {
            'function_id': 13,
            'name': 'Calibrate',
            'elements': [
                {
                    'name': 'Weight',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Tare',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        17: {
            'function_id': 17,
            'name': 'Weight',
            'elements': [
                {
                    'name': 'Weight',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        18: {
            'function_id': 18,
            'name': 'Weight Reached',
            'elements': [
                {
                    'name': 'Weight',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2104: {
    'device_identifier': 2104,
    'name': 'Load Cell Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Weight',
            'elements': [
                {
                    'name': 'Weight',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Weight Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Weight Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        4: {
            'function_id': 4,
            'name': 'Weight',
            'elements': [
                {
                    'name': 'Weight',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        5: {
            'function_id': 5,
            'name': 'Set Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        7: {
            'function_id': 7,
            'name': 'Set Info LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Info LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        9: {
            'function_id': 9,
            'name': 'Calibrate',
            'elements': [
                {
                    'name': 'Weight',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Tare',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Rate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Gain',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
232: {
    'device_identifier': 232,
    'name': 'Moisture Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Moisture Value',
            'elements': [
                {
                    'name': 'Moisture',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Moisture Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Moisture Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Moisture Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Moisture Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Moisture',
            'elements': [
                {
                    'name': 'Moisture',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        9: {
            'function_id': 9,
            'name': 'Moisture Reached',
            'elements': [
                {
                    'name': 'Moisture',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        10: {
            'function_id': 10,
            'name': 'Set Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Moving Average',
            'elements': [
                {
                    'name': 'Average',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
233: {
    'device_identifier': 233,
    'name': 'Motion Detector Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Motion Detected',
            'elements': [
                {
                    'name': 'Motion',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        2: {
            'function_id': 2,
            'name': 'Motion Detected',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Detection Cycle Ended',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
292: {
    'device_identifier': 292,
    'name': 'Motion Detector Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Motion Detected',
            'elements': [
                {
                    'name': 'Motion',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        2: {
            'function_id': 2,
            'name': 'Set Sensitivity',
            'elements': [
                {
                    'name': 'Sensitivity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Sensitivity',
            'elements': [
                {
                    'name': 'Sensitivity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        4: {
            'function_id': 4,
            'name': 'Set Indicator',
            'elements': [
                {
                    'name': 'Top Left',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Top Right',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Bottom',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Indicator',
            'elements': [
                {
                    'name': 'Top Left',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Top Right',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Bottom',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        6: {
            'function_id': 6,
            'name': 'Motion Detected',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Detection Cycle Ended',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
267: {
    'device_identifier': 267,
    'name': 'Motorized Linear Poti Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        4: {
            'function_id': 4,
            'name': 'Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Set Motor Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Drive Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Hold Position',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B !',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Motor Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Drive Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hold Position',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Position Reached',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B ! !',
        },
        7: {
            'function_id': 7,
            'name': 'Calibrate',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Set Position Reached Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Position Reached Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        10: {
            'function_id': 10,
            'name': 'Position Reached',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
234: {
    'device_identifier': 234,
    'name': 'Multi Touch Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Touch State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Recalibrate',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Set Electrode Config',
            'elements': [
                {
                    'name': 'Enabled Electrodes',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Electrode Config',
            'elements': [
                {
                    'name': 'Enabled Electrodes',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Touch State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Electrode Sensitivity',
            'elements': [
                {
                    'name': 'Sensitivity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Electrode Sensitivity',
            'elements': [
                {
                    'name': 'Sensitivity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2129: {
    'device_identifier': 2129,
    'name': 'Multi Touch Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Touch State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '13',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '13!',
        },
        2: {
            'function_id': 2,
            'name': 'Set Touch State Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Touch State Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        4: {
            'function_id': 4,
            'name': 'Touch State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '13',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '13!',
        },
        5: {
            'function_id': 5,
            'name': 'Recalibrate',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Set Electrode Config',
            'elements': [
                {
                    'name': 'Enabled Electrodes',
                    'type': 'bool',
                    'cardinality': '13',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '13!',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Electrode Config',
            'elements': [
                {
                    'name': 'Enabled Electrodes',
                    'type': 'bool',
                    'cardinality': '13',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '13!',
        },
        8: {
            'function_id': 8,
            'name': 'Set Electrode Sensitivity',
            'elements': [
                {
                    'name': 'Sensitivity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Electrode Sensitivity',
            'elements': [
                {
                    'name': 'Sensitivity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        10: {
            'function_id': 10,
            'name': 'Set Touch LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Touch LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
286: {
    'device_identifier': 286,
    'name': 'NFC Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        3: {
            'function_id': 3,
            'name': 'Reader Request Tag ID',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Reader Get Tag ID Low Level',
            'elements': [
                {
                    'name': 'Tag Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Tag ID Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Tag ID Data',
                    'type': 'uint8',
                    'cardinality': '32',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B 32B',
        },
        5: {
            'function_id': 5,
            'name': 'Reader Get State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Idle',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        6: {
            'function_id': 6,
            'name': 'Reader Write NDEF Low Level',
            'elements': [
                {
                    'name': 'NDEF Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'NDEF Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'NDEF Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H 60B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Reader Request NDEF',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Reader Read NDEF Low Level',
            'elements': [
                {
                    'name': 'NDEF Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'NDEF Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'NDEF Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 60B',
        },
        9: {
            'function_id': 9,
            'name': 'Reader Authenticate Mifare Classic Page',
            'elements': [
                {
                    'name': 'Page',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Key Number',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Key',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B 6B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Reader Write Page Low Level',
            'elements': [
                {
                    'name': 'Page',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data Chunk Data',
                    'type': 'uint8',
                    'cardinality': '58',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H H 58B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Reader Request Page',
            'elements': [
                {
                    'name': 'Page',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Reader Read Page Low Level',
            'elements': [
                {
                    'name': 'Data Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Data Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 60B',
        },
        13: {
            'function_id': 13,
            'name': 'Reader State Changed',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Idle',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        14: {
            'function_id': 14,
            'name': 'Cardemu Get State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Idle',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        15: {
            'function_id': 15,
            'name': 'Cardemu Start Discovery',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Cardemu Write NDEF Low Level',
            'elements': [
                {
                    'name': 'NDEF Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'NDEF Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'NDEF Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H 60B',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Cardemu Start Transfer',
            'elements': [
                {
                    'name': 'Transfer',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Cardemu State Changed',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Idle',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        19: {
            'function_id': 19,
            'name': 'P2P Get State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Idle',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        20: {
            'function_id': 20,
            'name': 'P2P Start Discovery',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        21: {
            'function_id': 21,
            'name': 'P2P Write NDEF Low Level',
            'elements': [
                {
                    'name': 'NDEF Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'NDEF Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'NDEF Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H 60B',
            'out_struct_format': '',
        },
        22: {
            'function_id': 22,
            'name': 'P2P Start Transfer',
            'elements': [
                {
                    'name': 'Transfer',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        23: {
            'function_id': 23,
            'name': 'P2P Read NDEF Low Level',
            'elements': [
                {
                    'name': 'NDEF Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'NDEF Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'NDEF Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 60B',
        },
        24: {
            'function_id': 24,
            'name': 'P2P State Changed',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Idle',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        25: {
            'function_id': 25,
            'name': 'Set Detection LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        26: {
            'function_id': 26,
            'name': 'Get Detection LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        27: {
            'function_id': 27,
            'name': 'Set Maximum Timeout',
            'elements': [
                {
                    'name': 'Timeout',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        28: {
            'function_id': 28,
            'name': 'Get Maximum Timeout',
            'elements': [
                {
                    'name': 'Timeout',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
246: {
    'device_identifier': 246,
    'name': 'NFC/RFID Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Request Tag ID',
            'elements': [
                {
                    'name': 'Tag Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Tag ID',
            'elements': [
                {
                    'name': 'Tag Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'TID Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'TID',
                    'type': 'uint8',
                    'cardinality': '7',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B 7B',
        },
        3: {
            'function_id': 3,
            'name': 'Get State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Idle',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        4: {
            'function_id': 4,
            'name': 'Authenticate Mifare Classic Page',
            'elements': [
                {
                    'name': 'Page',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Key Number',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Key',
                    'type': 'uint8',
                    'cardinality': '6',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B 6B',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Write Page',
            'elements': [
                {
                    'name': 'Page',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '16',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H 16B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Request Page',
            'elements': [
                {
                    'name': 'Page',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Page',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '16',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '16B',
        },
        8: {
            'function_id': 8,
            'name': 'State Changed',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Idle',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
263: {
    'device_identifier': 263,
    'name': 'OLED 128x64 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'New Window',
            'elements': [
                {
                    'name': 'Column From',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Column To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Row From',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Row To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Clear Display',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Display Configuration',
            'elements': [
                {
                    'name': 'Contrast',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Invert',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Display Configuration',
            'elements': [
                {
                    'name': 'Contrast',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Invert',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        6: {
            'function_id': 6,
            'name': 'Write Line',
            'elements': [
                {
                    'name': 'Line',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '26',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B 26s',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2112: {
    'device_identifier': 2112,
    'name': 'OLED 128x64 Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write Pixels Low Level',
            'elements': [
                {
                    'name': 'X Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'X End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Chunk Data',
                    'type': 'bool',
                    'cardinality': '448',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B H H 448!',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Read Pixels Low Level',
            'elements': [
                {
                    'name': 'X Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y Start',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'X End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Y End',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pixels Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pixels Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Pixels Chunk Data',
                    'type': 'bool',
                    'cardinality': '480',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B B B B',
            'out_struct_format': 'H H 480!',
        },
        3: {
            'function_id': 3,
            'name': 'Clear Display',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Display Configuration',
            'elements': [
                {
                    'name': 'Contrast',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Invert',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Automatic Draw',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B ! !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Display Configuration',
            'elements': [
                {
                    'name': 'Contrast',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Invert',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Automatic Draw',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B ! !',
        },
        6: {
            'function_id': 6,
            'name': 'Write Line',
            'elements': [
                {
                    'name': 'Line',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '22',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B 22s',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Draw Buffered Frame',
            'elements': [
                {
                    'name': 'Force Complete Redraw',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
264: {
    'device_identifier': 264,
    'name': 'OLED 64x48 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'New Window',
            'elements': [
                {
                    'name': 'Column From',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Column To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Row From',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Row To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Clear Display',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Display Configuration',
            'elements': [
                {
                    'name': 'Contrast',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Invert',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Display Configuration',
            'elements': [
                {
                    'name': 'Contrast',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Invert',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B !',
        },
        6: {
            'function_id': 6,
            'name': 'Write Line',
            'elements': [
                {
                    'name': 'Line',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Position',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Text',
                    'type': 'string',
                    'cardinality': '13',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B 13s',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2123: {
    'device_identifier': 2123,
    'name': 'One Wire Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Search Bus Low Level',
            'elements': [
                {
                    'name': 'Identifier Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifier Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifier Chunk Data',
                    'type': 'uint64',
                    'cardinality': '7',
                    'direction': 'out'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 7Q B',
        },
        2: {
            'function_id': 2,
            'name': 'Reset Bus',
            'elements': [
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        3: {
            'function_id': 3,
            'name': 'Write',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        4: {
            'function_id': 4,
            'name': 'Read',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        5: {
            'function_id': 5,
            'name': 'Write Command',
            'elements': [
                {
                    'name': 'Identifier',
                    'type': 'uint64',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Command',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'Q B',
            'out_struct_format': 'B',
        },
        6: {
            'function_id': 6,
            'name': 'Set Communication LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Communication LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
288: {
    'device_identifier': 288,
    'name': 'Outdoor Weather Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Station Identifiers Low Level',
            'elements': [
                {
                    'name': 'Identifiers Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifiers Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifiers Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 60B',
        },
        2: {
            'function_id': 2,
            'name': 'Get Sensor Identifiers Low Level',
            'elements': [
                {
                    'name': 'Identifiers Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifiers Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Identifiers Chunk Data',
                    'type': 'uint8',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 60B',
        },
        3: {
            'function_id': 3,
            'name': 'Get Station Data',
            'elements': [
                {
                    'name': 'Identifier',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Humidity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Wind Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Gust Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Rain',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Wind Direction',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Battery Low',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Last Change',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'h B I I I B ! H',
        },
        4: {
            'function_id': 4,
            'name': 'Get Sensor Data',
            'elements': [
                {
                    'name': 'Identifier',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Humidity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Last Change',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'h B H',
        },
        5: {
            'function_id': 5,
            'name': 'Set Station Callback Configuration',
            'elements': [
                {
                    'name': 'Enable Callback',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Station Callback Configuration',
            'elements': [
                {
                    'name': 'Enable Callback',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        7: {
            'function_id': 7,
            'name': 'Set Sensor Callback Configuration',
            'elements': [
                {
                    'name': 'Enable Callback',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Sensor Callback Configuration',
            'elements': [
                {
                    'name': 'Enable Callback',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        9: {
            'function_id': 9,
            'name': 'Station Data',
            'elements': [
                {
                    'name': 'Identifier',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Humidity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Wind Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Gust Speed',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Rain',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Wind Direction',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Battery Low',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B h B I I I B !',
        },
        10: {
            'function_id': 10,
            'name': 'Sensor Data',
            'elements': [
                {
                    'name': 'Identifier',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Humidity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B h B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2110: {
    'device_identifier': 2110,
    'name': 'Particulate Matter Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get PM Concentration',
            'elements': [
                {
                    'name': 'PM10',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'PM25',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'PM100',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H',
        },
        2: {
            'function_id': 2,
            'name': 'Get PM Count',
            'elements': [
                {
                    'name': 'Greater03um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater05um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater10um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater25um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater50um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater100um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H H H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Enable',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Enable',
            'elements': [
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        5: {
            'function_id': 5,
            'name': 'Get Sensor Info',
            'elements': [
                {
                    'name': 'Sensor Version',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Last Error Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Framing Error Count',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Checksum Error Count',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B B',
        },
        6: {
            'function_id': 6,
            'name': 'Set PM Concentration Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get PM Concentration Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        8: {
            'function_id': 8,
            'name': 'Set PM Count Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get PM Count Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        10: {
            'function_id': 10,
            'name': 'PM Concentration',
            'elements': [
                {
                    'name': 'PM10',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'PM25',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'PM100',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H',
        },
        11: {
            'function_id': 11,
            'name': 'PM Count',
            'elements': [
                {
                    'name': 'Greater03um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater05um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater10um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater25um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater50um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Greater100um',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H H H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
214: {
    'device_identifier': 214,
    'name': 'Piezo Buzzer Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Beep',
            'elements': [
                {
                    'name': 'Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Morse Code',
            'elements': [
                {
                    'name': 'Morse',
                    'type': 'string',
                    'cardinality': '60',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '60s',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Beep Finished',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Morse Code Finished',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
242: {
    'device_identifier': 242,
    'name': 'Piezo Speaker Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Beep',
            'elements': [
                {
                    'name': 'Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I H',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Morse Code',
            'elements': [
                {
                    'name': 'Morse',
                    'type': 'string',
                    'cardinality': '60',
                    'direction': 'in'
                },
                {
                    'name': 'Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '60s H',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Calibrate',
            'elements': [
                {
                    'name': 'Calibration',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        4: {
            'function_id': 4,
            'name': 'Beep Finished',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Morse Code Finished',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2145: {
    'device_identifier': 2145,
    'name': 'Piezo Speaker Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Beep',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Volume',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B I',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Beep',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Volume',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duration Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B I I',
        },
        3: {
            'function_id': 3,
            'name': 'Set Alarm',
            'elements': [
                {
                    'name': 'Start Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'End Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Step Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Step Delay',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Volume',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H H H B I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Alarm',
            'elements': [
                {
                    'name': 'Start Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'End Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Step Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Step Delay',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Volume',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duration',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duration Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H B I I H',
        },
        5: {
            'function_id': 5,
            'name': 'Update Volume',
            'elements': [
                {
                    'name': 'Volume',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Update Frequency',
            'elements': [
                {
                    'name': 'Frequency',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Beep Finished',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Alarm Finished',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
226: {
    'device_identifier': 226,
    'name': 'PTC Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Get Resistance',
            'elements': [
                {
                    'name': 'Resistance',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        3: {
            'function_id': 3,
            'name': 'Set Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Resistance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Resistance Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        9: {
            'function_id': 9,
            'name': 'Set Resistance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Resistance Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        14: {
            'function_id': 14,
            'name': 'Temperature Reached',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        15: {
            'function_id': 15,
            'name': 'Resistance',
            'elements': [
                {
                    'name': 'Resistance',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        16: {
            'function_id': 16,
            'name': 'Resistance Reached',
            'elements': [
                {
                    'name': 'Resistance',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        17: {
            'function_id': 17,
            'name': 'Set Noise Rejection Filter',
            'elements': [
                {
                    'name': 'Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        18: {
            'function_id': 18,
            'name': 'Get Noise Rejection Filter',
            'elements': [
                {
                    'name': 'Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        19: {
            'function_id': 19,
            'name': 'Is Sensor Connected',
            'elements': [
                {
                    'name': 'Connected',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        20: {
            'function_id': 20,
            'name': 'Set Wire Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        21: {
            'function_id': 21,
            'name': 'Get Wire Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        22: {
            'function_id': 22,
            'name': 'Set Sensor Connected Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        23: {
            'function_id': 23,
            'name': 'Get Sensor Connected Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        24: {
            'function_id': 24,
            'name': 'Sensor Connected',
            'elements': [
                {
                    'name': 'Connected',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2101: {
    'device_identifier': 2101,
    'name': 'PTC Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        4: {
            'function_id': 4,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        5: {
            'function_id': 5,
            'name': 'Get Resistance',
            'elements': [
                {
                    'name': 'Resistance',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        6: {
            'function_id': 6,
            'name': 'Set Resistance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Resistance Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        8: {
            'function_id': 8,
            'name': 'Resistance',
            'elements': [
                {
                    'name': 'Resistance',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        9: {
            'function_id': 9,
            'name': 'Set Noise Rejection Filter',
            'elements': [
                {
                    'name': 'Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Noise Rejection Filter',
            'elements': [
                {
                    'name': 'Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        11: {
            'function_id': 11,
            'name': 'Is Sensor Connected',
            'elements': [
                {
                    'name': 'Connected',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        12: {
            'function_id': 12,
            'name': 'Set Wire Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Wire Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        14: {
            'function_id': 14,
            'name': 'Set Moving Average Configuration',
            'elements': [
                {
                    'name': 'Moving Average Length Resistance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Moving Average Length Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Moving Average Configuration',
            'elements': [
                {
                    'name': 'Moving Average Length Resistance',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Moving Average Length Temperature',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        16: {
            'function_id': 16,
            'name': 'Set Sensor Connected Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Get Sensor Connected Callback Configuration',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        18: {
            'function_id': 18,
            'name': 'Sensor Connected',
            'elements': [
                {
                    'name': 'Connected',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
268: {
    'device_identifier': 268,
    'name': 'Real-Time Clock Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Date Time',
            'elements': [
                {
                    'name': 'Year',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Month',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Day',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Hour',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minute',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Second',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Centisecond',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Weekday',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B B B B B B B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Date Time',
            'elements': [
                {
                    'name': 'Year',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Month',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Day',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hour',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minute',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Second',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Centisecond',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Weekday',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B B B B B B B',
        },
        3: {
            'function_id': 3,
            'name': 'Get Timestamp',
            'elements': [
                {
                    'name': 'Timestamp',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'q',
        },
        4: {
            'function_id': 4,
            'name': 'Set Offset',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'b',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Offset',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'b',
        },
        6: {
            'function_id': 6,
            'name': 'Set Date Time Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Date Time Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Set Alarm',
            'elements': [
                {
                    'name': 'Month',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Day',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Hour',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minute',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Second',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Weekday',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Interval',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'b b b b b b i',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Alarm',
            'elements': [
                {
                    'name': 'Month',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Day',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hour',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minute',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Second',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Weekday',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Interval',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'b b b b b b i',
        },
        10: {
            'function_id': 10,
            'name': 'Date Time',
            'elements': [
                {
                    'name': 'Year',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Month',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Day',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hour',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minute',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Second',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Centisecond',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Weekday',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Timestamp',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B B B B B B B q',
        },
        11: {
            'function_id': 11,
            'name': 'Alarm',
            'elements': [
                {
                    'name': 'Year',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Month',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Day',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hour',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minute',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Second',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Centisecond',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Weekday',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Timestamp',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B B B B B B B q',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2106: {
    'device_identifier': 2106,
    'name': 'Real-Time Clock Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Date Time',
            'elements': [
                {
                    'name': 'Year',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Month',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Day',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Hour',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minute',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Second',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Centisecond',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Weekday',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H B B B B B B B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Date Time',
            'elements': [
                {
                    'name': 'Year',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Month',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Day',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hour',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minute',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Second',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Centisecond',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Weekday',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Timestamp',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B B B B B B B q',
        },
        3: {
            'function_id': 3,
            'name': 'Get Timestamp',
            'elements': [
                {
                    'name': 'Timestamp',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'q',
        },
        4: {
            'function_id': 4,
            'name': 'Set Offset',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'b',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Offset',
            'elements': [
                {
                    'name': 'Offset',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'b',
        },
        6: {
            'function_id': 6,
            'name': 'Set Date Time Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Date Time Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Set Alarm',
            'elements': [
                {
                    'name': 'Month',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Day',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Hour',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minute',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Second',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Weekday',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Interval',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'b b b b b b i',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Alarm',
            'elements': [
                {
                    'name': 'Month',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Day',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hour',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minute',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Second',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Weekday',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Interval',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'b b b b b b i',
        },
        10: {
            'function_id': 10,
            'name': 'Date Time',
            'elements': [
                {
                    'name': 'Year',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Month',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Day',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hour',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minute',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Second',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Centisecond',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Weekday',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Timestamp',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B B B B B B B q',
        },
        11: {
            'function_id': 11,
            'name': 'Alarm',
            'elements': [
                {
                    'name': 'Year',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Month',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Day',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hour',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minute',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Second',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Centisecond',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Weekday',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Timestamp',
                    'type': 'int64',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H B B B B B B B q',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
235: {
    'device_identifier': 235,
    'name': 'Remote Switch Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Switch Socket',
            'elements': [
                {
                    'name': 'House Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Receiver Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Switching State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        3: {
            'function_id': 3,
            'name': 'Switching Done',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Set Repeats',
            'elements': [
                {
                    'name': 'Repeats',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Repeats',
            'elements': [
                {
                    'name': 'Repeats',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        6: {
            'function_id': 6,
            'name': 'Switch Socket A',
            'elements': [
                {
                    'name': 'House Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Receiver Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Switch Socket B',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Unit',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I B B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Dim Socket B',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Unit',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Dim Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I B B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Switch Socket C',
            'elements': [
                {
                    'name': 'System Code',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Device Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B B',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
289: {
    'device_identifier': 289,
    'name': 'Remote Switch Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Switching State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        2: {
            'function_id': 2,
            'name': 'Switching Done',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Set Repeats',
            'elements': [
                {
                    'name': 'Repeats',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Repeats',
            'elements': [
                {
                    'name': 'Repeats',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        5: {
            'function_id': 5,
            'name': 'Switch Socket A',
            'elements': [
                {
                    'name': 'House Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Receiver Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Switch Socket B',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Unit',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I B B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Dim Socket B',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Unit',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Dim Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I B B',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Switch Socket C',
            'elements': [
                {
                    'name': 'System Code',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Device Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c B B',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Set Remote Configuration',
            'elements': [
                {
                    'name': 'Remote Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Minimum Repeats',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H !',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Remote Configuration',
            'elements': [
                {
                    'name': 'Remote Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Minimum Repeats',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Callback Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B H !',
        },
        11: {
            'function_id': 11,
            'name': 'Get Remote Status A',
            'elements': [
                {
                    'name': 'House Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Receiver Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Repeats',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B H',
        },
        12: {
            'function_id': 12,
            'name': 'Get Remote Status B',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Unit',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Dim Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Repeats',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I B B B H',
        },
        13: {
            'function_id': 13,
            'name': 'Get Remote Status C',
            'elements': [
                {
                    'name': 'System Code',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Device Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Repeats',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c B B H',
        },
        14: {
            'function_id': 14,
            'name': 'Remote Status A',
            'elements': [
                {
                    'name': 'House Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Receiver Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Repeats',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B H',
        },
        15: {
            'function_id': 15,
            'name': 'Remote Status B',
            'elements': [
                {
                    'name': 'Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Unit',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Dim Value',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Repeats',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I B B B H',
        },
        16: {
            'function_id': 16,
            'name': 'Remote Status C',
            'elements': [
                {
                    'name': 'System Code',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Device Code',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Switch To',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Repeats',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c B B H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
282: {
    'device_identifier': 282,
    'name': 'RGB LED Button Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Color',
            'elements': [
                {
                    'name': 'Red',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Green',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Blue',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Color',
            'elements': [
                {
                    'name': 'Red',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Green',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Blue',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        3: {
            'function_id': 3,
            'name': 'Get Button State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        4: {
            'function_id': 4,
            'name': 'Button State Changed',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        5: {
            'function_id': 5,
            'name': 'Set Color Calibration',
            'elements': [
                {
                    'name': 'Red',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Green',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Blue',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Color Calibration',
            'elements': [
                {
                    'name': 'Red',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Green',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Blue',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
271: {
    'device_identifier': 271,
    'name': 'RGB LED Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set RGB Value',
            'elements': [
                {
                    'name': 'R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'G',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'B',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get RGB Value',
            'elements': [
                {
                    'name': 'R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'G',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'B',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
272: {
    'device_identifier': 272,
    'name': 'RGB LED Matrix Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Red',
            'elements': [
                {
                    'name': 'Red',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Red',
            'elements': [
                {
                    'name': 'Red',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64B',
        },
        3: {
            'function_id': 3,
            'name': 'Set Green',
            'elements': [
                {
                    'name': 'Green',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Green',
            'elements': [
                {
                    'name': 'Green',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64B',
        },
        5: {
            'function_id': 5,
            'name': 'Set Blue',
            'elements': [
                {
                    'name': 'Blue',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Blue',
            'elements': [
                {
                    'name': 'Blue',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '64B',
        },
        7: {
            'function_id': 7,
            'name': 'Set Frame Duration',
            'elements': [
                {
                    'name': 'Frame Duration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Frame Duration',
            'elements': [
                {
                    'name': 'Frame Duration',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        9: {
            'function_id': 9,
            'name': 'Draw Frame',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Supply Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        11: {
            'function_id': 11,
            'name': 'Frame Started',
            'elements': [
                {
                    'name': 'Frame Number',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2127: {
    'device_identifier': 2127,
    'name': 'RGB LED Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set RGB Value',
            'elements': [
                {
                    'name': 'R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'G',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'B',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get RGB Value',
            'elements': [
                {
                    'name': 'R',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'G',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'B',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
236: {
    'device_identifier': 236,
    'name': 'Rotary Encoder Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Count',
            'elements': [
                {
                    'name': 'Reset',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Count Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Count Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Count Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Count Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Count',
            'elements': [
                {
                    'name': 'Count',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        9: {
            'function_id': 9,
            'name': 'Count Reached',
            'elements': [
                {
                    'name': 'Count',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        10: {
            'function_id': 10,
            'name': 'Is Pressed',
            'elements': [
                {
                    'name': 'Pressed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        11: {
            'function_id': 11,
            'name': 'Pressed',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Released',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
294: {
    'device_identifier': 294,
    'name': 'Rotary Encoder Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Count',
            'elements': [
                {
                    'name': 'Reset',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Count Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Count Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        4: {
            'function_id': 4,
            'name': 'Count',
            'elements': [
                {
                    'name': 'Count',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        5: {
            'function_id': 5,
            'name': 'Is Pressed',
            'elements': [
                {
                    'name': 'Pressed',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        6: {
            'function_id': 6,
            'name': 'Pressed',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Released',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
215: {
    'device_identifier': 215,
    'name': 'Rotary Poti Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Position Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Position Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Position Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c h h',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Position Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c h h',
        },
        9: {
            'function_id': 9,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        14: {
            'function_id': 14,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        15: {
            'function_id': 15,
            'name': 'Position Reached',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2140: {
    'device_identifier': 2140,
    'name': 'Rotary Poti Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Set Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Position Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        4: {
            'function_id': 4,
            'name': 'Position',
            'elements': [
                {
                    'name': 'Position',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
254: {
    'device_identifier': 254,
    'name': 'RS232 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write',
            'elements': [
                {
                    'name': 'Message',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Written',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '60c B',
            'out_struct_format': 'B',
        },
        2: {
            'function_id': 2,
            'name': 'Read',
            'elements': [
                {
                    'name': 'Message',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'out'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '60c B',
        },
        3: {
            'function_id': 3,
            'name': 'Enable Read Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Disable Read Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Is Read Callback Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        6: {
            'function_id': 6,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Baudrate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Parity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stopbits',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Wordlength',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Hardware Flowcontrol',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Software Flowcontrol',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B B B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Baudrate',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Parity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stopbits',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Wordlength',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Flowcontrol',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Software Flowcontrol',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B B B B',
        },
        8: {
            'function_id': 8,
            'name': 'Read',
            'elements': [
                {
                    'name': 'Message',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'out'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '60c B',
        },
        9: {
            'function_id': 9,
            'name': 'Error',
            'elements': [
                {
                    'name': 'Error',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        10: {
            'function_id': 10,
            'name': 'Set Break Condition',
            'elements': [
                {
                    'name': 'Break Time',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Set Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Frame Size',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Frame Size',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        13: {
            'function_id': 13,
            'name': 'Frame Readable',
            'elements': [
                {
                    'name': 'Frame Count',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        14: {
            'function_id': 14,
            'name': 'Read Frame',
            'elements': [
                {
                    'name': 'Message',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'out'
                },
                {
                    'name': 'Length',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '60c B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2108: {
    'device_identifier': 2108,
    'name': 'RS232 Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write Low Level',
            'elements': [
                {
                    'name': 'Message Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Message Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Message Chunk Data',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'in'
                },
                {
                    'name': 'Message Chunk Written',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H 60c',
            'out_struct_format': 'B',
        },
        2: {
            'function_id': 2,
            'name': 'Read Low Level',
            'elements': [
                {
                    'name': 'Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Message Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Message Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Message Chunk Data',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'H H 60c',
        },
        3: {
            'function_id': 3,
            'name': 'Enable Read Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Disable Read Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Is Read Callback Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        6: {
            'function_id': 6,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Parity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stopbits',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Wordlength',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Flowcontrol',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I B B B B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Parity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stopbits',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Wordlength',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Flowcontrol',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I B B B B',
        },
        8: {
            'function_id': 8,
            'name': 'Set Buffer Config',
            'elements': [
                {
                    'name': 'Send Buffer Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Receive Buffer Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Buffer Config',
            'elements': [
                {
                    'name': 'Send Buffer Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Receive Buffer Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        10: {
            'function_id': 10,
            'name': 'Get Buffer Status',
            'elements': [
                {
                    'name': 'Send Buffer Used',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Receive Buffer Used',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        11: {
            'function_id': 11,
            'name': 'Get Error Count',
            'elements': [
                {
                    'name': 'Error Count Overrun',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Parity',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        12: {
            'function_id': 12,
            'name': 'Read Low Level',
            'elements': [
                {
                    'name': 'Message Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Message Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Message Chunk Data',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 60c',
        },
        13: {
            'function_id': 13,
            'name': 'Error Count',
            'elements': [
                {
                    'name': 'Error Count Overrun',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Parity',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        14: {
            'function_id': 14,
            'name': 'Set Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Frame Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Frame Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        16: {
            'function_id': 16,
            'name': 'Frame Readable',
            'elements': [
                {
                    'name': 'Frame Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
277: {
    'device_identifier': 277,
    'name': 'RS485 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Write Low Level',
            'elements': [
                {
                    'name': 'Message Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Message Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Message Chunk Data',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'in'
                },
                {
                    'name': 'Message Chunk Written',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H H 60c',
            'out_struct_format': 'B',
        },
        2: {
            'function_id': 2,
            'name': 'Read Low Level',
            'elements': [
                {
                    'name': 'Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Message Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Message Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Message Chunk Data',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': 'H H 60c',
        },
        3: {
            'function_id': 3,
            'name': 'Enable Read Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Disable Read Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Is Read Callback Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        6: {
            'function_id': 6,
            'name': 'Set RS485 Configuration',
            'elements': [
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Parity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Stopbits',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Wordlength',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Duplex',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I B B B B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get RS485 Configuration',
            'elements': [
                {
                    'name': 'Baudrate',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Parity',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Stopbits',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Wordlength',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Duplex',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I B B B B',
        },
        8: {
            'function_id': 8,
            'name': 'Set Modbus Configuration',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Master Request Timeout',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B I',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Modbus Configuration',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Master Request Timeout',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I',
        },
        10: {
            'function_id': 10,
            'name': 'Set Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        12: {
            'function_id': 12,
            'name': 'Set Communication LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Communication LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        14: {
            'function_id': 14,
            'name': 'Set Error LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Error LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        16: {
            'function_id': 16,
            'name': 'Set Buffer Config',
            'elements': [
                {
                    'name': 'Send Buffer Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Receive Buffer Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Get Buffer Config',
            'elements': [
                {
                    'name': 'Send Buffer Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Receive Buffer Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        18: {
            'function_id': 18,
            'name': 'Get Buffer Status',
            'elements': [
                {
                    'name': 'Send Buffer Used',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Receive Buffer Used',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        19: {
            'function_id': 19,
            'name': 'Enable Error Count Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        20: {
            'function_id': 20,
            'name': 'Disable Error Count Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        21: {
            'function_id': 21,
            'name': 'Is Error Count Callback Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        22: {
            'function_id': 22,
            'name': 'Get Error Count',
            'elements': [
                {
                    'name': 'Overrun Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Parity Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        23: {
            'function_id': 23,
            'name': 'Get Modbus Common Error Count',
            'elements': [
                {
                    'name': 'Timeout Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Checksum Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Frame Too Big Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Illegal Function Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Illegal Data Address Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Illegal Data Value Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Slave Device Failure Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I I I I',
        },
        24: {
            'function_id': 24,
            'name': 'Modbus Slave Report Exception',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Exception Code',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B b',
            'out_struct_format': '',
        },
        25: {
            'function_id': 25,
            'name': 'Modbus Slave Answer Read Coils Request Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Coils Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Coils Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Coils Chunk Data',
                    'type': 'bool',
                    'cardinality': '472',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H H 472!',
            'out_struct_format': '',
        },
        26: {
            'function_id': 26,
            'name': 'Modbus Master Read Coils',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I H',
            'out_struct_format': 'B',
        },
        27: {
            'function_id': 27,
            'name': 'Modbus Slave Answer Read Holding Registers Request Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Holding Registers Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Holding Registers Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Holding Registers Chunk Data',
                    'type': 'uint16',
                    'cardinality': '29',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H H 29H',
            'out_struct_format': '',
        },
        28: {
            'function_id': 28,
            'name': 'Modbus Master Read Holding Registers',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I H',
            'out_struct_format': 'B',
        },
        29: {
            'function_id': 29,
            'name': 'Modbus Slave Answer Write Single Coil Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        30: {
            'function_id': 30,
            'name': 'Modbus Master Write Single Coil',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Coil Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Coil Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I !',
            'out_struct_format': 'B',
        },
        31: {
            'function_id': 31,
            'name': 'Modbus Slave Answer Write Single Register Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        32: {
            'function_id': 32,
            'name': 'Modbus Master Write Single Register',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Register Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Register Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I H',
            'out_struct_format': 'B',
        },
        33: {
            'function_id': 33,
            'name': 'Modbus Slave Answer Write Multiple Coils Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        34: {
            'function_id': 34,
            'name': 'Modbus Master Write Multiple Coils Low Level',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Coils Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Coils Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Coils Chunk Data',
                    'type': 'bool',
                    'cardinality': '440',
                    'direction': 'in'
                },
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I H H 440!',
            'out_struct_format': 'B',
        },
        35: {
            'function_id': 35,
            'name': 'Modbus Slave Answer Write Multiple Registers Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        36: {
            'function_id': 36,
            'name': 'Modbus Master Write Multiple Registers Low Level',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Registers Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Registers Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Registers Chunk Data',
                    'type': 'uint16',
                    'cardinality': '27',
                    'direction': 'in'
                },
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I H H 27H',
            'out_struct_format': 'B',
        },
        37: {
            'function_id': 37,
            'name': 'Modbus Slave Answer Read Discrete Inputs Request Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Discrete Inputs Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Discrete Inputs Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Discrete Inputs Chunk Data',
                    'type': 'bool',
                    'cardinality': '472',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H H 472!',
            'out_struct_format': '',
        },
        38: {
            'function_id': 38,
            'name': 'Modbus Master Read Discrete Inputs',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I H',
            'out_struct_format': 'B',
        },
        39: {
            'function_id': 39,
            'name': 'Modbus Slave Answer Read Input Registers Request Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Input Registers Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Input Registers Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Input Registers Chunk Data',
                    'type': 'uint16',
                    'cardinality': '29',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B H H 29H',
            'out_struct_format': '',
        },
        40: {
            'function_id': 40,
            'name': 'Modbus Master Read Input Registers',
            'elements': [
                {
                    'name': 'Slave Address',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B I H',
            'out_struct_format': 'B',
        },
        41: {
            'function_id': 41,
            'name': 'Read Low Level',
            'elements': [
                {
                    'name': 'Message Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Message Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Message Chunk Data',
                    'type': 'char',
                    'cardinality': '60',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 60c',
        },
        42: {
            'function_id': 42,
            'name': 'Error Count',
            'elements': [
                {
                    'name': 'Overrun Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Parity Error Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I',
        },
        43: {
            'function_id': 43,
            'name': 'Modbus Slave Read Coils Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I H',
        },
        44: {
            'function_id': 44,
            'name': 'Modbus Master Read Coils Response Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exception Code',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Coils Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Coils Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Coils Chunk Data',
                    'type': 'bool',
                    'cardinality': '464',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B b H H 464!',
        },
        45: {
            'function_id': 45,
            'name': 'Modbus Slave Read Holding Registers Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I H',
        },
        46: {
            'function_id': 46,
            'name': 'Modbus Master Read Holding Registers Response Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exception Code',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Holding Registers Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Holding Registers Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Holding Registers Chunk Data',
                    'type': 'uint16',
                    'cardinality': '29',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B b H H 29H',
        },
        47: {
            'function_id': 47,
            'name': 'Modbus Slave Write Single Coil Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Coil Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Coil Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I !',
        },
        48: {
            'function_id': 48,
            'name': 'Modbus Master Write Single Coil Response',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exception Code',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B b',
        },
        49: {
            'function_id': 49,
            'name': 'Modbus Slave Write Single Register Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Register Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Register Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I H',
        },
        50: {
            'function_id': 50,
            'name': 'Modbus Master Write Single Register Response',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exception Code',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B b',
        },
        51: {
            'function_id': 51,
            'name': 'Modbus Slave Write Multiple Coils Request Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Coils Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Coils Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Coils Chunk Data',
                    'type': 'bool',
                    'cardinality': '440',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I H H 440!',
        },
        52: {
            'function_id': 52,
            'name': 'Modbus Master Write Multiple Coils Response',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exception Code',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B b',
        },
        53: {
            'function_id': 53,
            'name': 'Modbus Slave Write Multiple Registers Request Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Registers Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Registers Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Registers Chunk Data',
                    'type': 'uint16',
                    'cardinality': '27',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I H H 27H',
        },
        54: {
            'function_id': 54,
            'name': 'Modbus Master Write Multiple Registers Response',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exception Code',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B b',
        },
        55: {
            'function_id': 55,
            'name': 'Modbus Slave Read Discrete Inputs Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I H',
        },
        56: {
            'function_id': 56,
            'name': 'Modbus Master Read Discrete Inputs Response Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exception Code',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Discrete Inputs Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Discrete Inputs Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Discrete Inputs Chunk Data',
                    'type': 'bool',
                    'cardinality': '464',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B b H H 464!',
        },
        57: {
            'function_id': 57,
            'name': 'Modbus Slave Read Input Registers Request',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Starting Address',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B I H',
        },
        58: {
            'function_id': 58,
            'name': 'Modbus Master Read Input Registers Response Low Level',
            'elements': [
                {
                    'name': 'Request ID',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Exception Code',
                    'type': 'int8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Input Registers Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Input Registers Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Input Registers Chunk Data',
                    'type': 'uint16',
                    'cardinality': '29',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B b H H 29H',
        },
        59: {
            'function_id': 59,
            'name': 'Set Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Frame Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        60: {
            'function_id': 60,
            'name': 'Get Frame Readable Callback Configuration',
            'elements': [
                {
                    'name': 'Frame Size',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        61: {
            'function_id': 61,
            'name': 'Frame Readable',
            'elements': [
                {
                    'name': 'Frame Count',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
237: {
    'device_identifier': 237,
    'name': 'Segment Display 4x7 Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Segments',
            'elements': [
                {
                    'name': 'Segments',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Brightness',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Colon',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4B B !',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Segments',
            'elements': [
                {
                    'name': 'Segments',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Brightness',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Colon',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4B B !',
        },
        3: {
            'function_id': 3,
            'name': 'Start Counter',
            'elements': [
                {
                    'name': 'Value From',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value To',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Increment',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'h h h I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Counter Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Counter Finished',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2137: {
    'device_identifier': 2137,
    'name': 'Segment Display 4x7 Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set Segments',
            'elements': [
                {
                    'name': 'Digit0',
                    'type': 'bool',
                    'cardinality': '8',
                    'direction': 'in'
                },
                {
                    'name': 'Digit1',
                    'type': 'bool',
                    'cardinality': '8',
                    'direction': 'in'
                },
                {
                    'name': 'Digit2',
                    'type': 'bool',
                    'cardinality': '8',
                    'direction': 'in'
                },
                {
                    'name': 'Digit3',
                    'type': 'bool',
                    'cardinality': '8',
                    'direction': 'in'
                },
                {
                    'name': 'Colon',
                    'type': 'bool',
                    'cardinality': '2',
                    'direction': 'in'
                },
                {
                    'name': 'Tick',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '8! 8! 8! 8! 2! !',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get Segments',
            'elements': [
                {
                    'name': 'Digit0',
                    'type': 'bool',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Digit1',
                    'type': 'bool',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Digit2',
                    'type': 'bool',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Digit3',
                    'type': 'bool',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Colon',
                    'type': 'bool',
                    'cardinality': '2',
                    'direction': 'out'
                },
                {
                    'name': 'Tick',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8! 8! 8! 8! 2! !',
        },
        3: {
            'function_id': 3,
            'name': 'Set Brightness',
            'elements': [
                {
                    'name': 'Brightness',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Brightness',
            'elements': [
                {
                    'name': 'Brightness',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        5: {
            'function_id': 5,
            'name': 'Set Numeric Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'int8',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4b',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Set Selected Segment',
            'elements': [
                {
                    'name': 'Segment',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Selected Segment',
            'elements': [
                {
                    'name': 'Segment',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '!',
        },
        8: {
            'function_id': 8,
            'name': 'Start Counter',
            'elements': [
                {
                    'name': 'Value From',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value To',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Increment',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Length',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'h h h I',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Counter Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        10: {
            'function_id': 10,
            'name': 'Counter Finished',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
244: {
    'device_identifier': 244,
    'name': 'Solid State Relay Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        3: {
            'function_id': 3,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I I',
        },
        5: {
            'function_id': 5,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
296: {
    'device_identifier': 296,
    'name': 'Solid State Relay Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '!',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        3: {
            'function_id': 3,
            'name': 'Set Monoflop',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '! I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Monoflop',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Time Remaining',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! I I',
        },
        5: {
            'function_id': 5,
            'name': 'Monoflop Done',
            'elements': [
                {
                    'name': 'State',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
238: {
    'device_identifier': 238,
    'name': 'Sound Intensity Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Intensity',
            'elements': [
                {
                    'name': 'Intensity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Intensity Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Intensity Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Intensity Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Intensity Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Intensity',
            'elements': [
                {
                    'name': 'Intensity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        9: {
            'function_id': 9,
            'name': 'Intensity Reached',
            'elements': [
                {
                    'name': 'Intensity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
290: {
    'device_identifier': 290,
    'name': 'Sound Pressure Level Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Decibel',
            'elements': [
                {
                    'name': 'Decibel',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Set Decibel Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c H H',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Decibel Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c H H',
        },
        4: {
            'function_id': 4,
            'name': 'Decibel',
            'elements': [
                {
                    'name': 'Decibel',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Get Spectrum Low Level',
            'elements': [
                {
                    'name': 'Spectrum Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Spectrum Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Spectrum Chunk Data',
                    'type': 'uint16',
                    'cardinality': '30',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 30H',
        },
        6: {
            'function_id': 6,
            'name': 'Set Spectrum Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Spectrum Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Spectrum Low Level',
            'elements': [
                {
                    'name': 'Spectrum Length',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Spectrum Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Spectrum Chunk Data',
                    'type': 'uint16',
                    'cardinality': '30',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H 30H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'FFT Size',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Weighting',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'FFT Size',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Weighting',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
216: {
    'device_identifier': 216,
    'name': 'Temperature Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Set Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c h h',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c h h',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        9: {
            'function_id': 9,
            'name': 'Temperature Reached',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        10: {
            'function_id': 10,
            'name': 'Set I2C Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get I2C Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
217: {
    'device_identifier': 217,
    'name': 'Temperature IR Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Ambient Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Get Object Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        3: {
            'function_id': 3,
            'name': 'Set Emissivity',
            'elements': [
                {
                    'name': 'Emissivity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Emissivity',
            'elements': [
                {
                    'name': 'Emissivity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        5: {
            'function_id': 5,
            'name': 'Set Ambient Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Ambient Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Object Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Object Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'Set Ambient Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c h h',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Ambient Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c h h',
        },
        11: {
            'function_id': 11,
            'name': 'Set Object Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c h h',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Object Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c h h',
        },
        13: {
            'function_id': 13,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        15: {
            'function_id': 15,
            'name': 'Ambient Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        16: {
            'function_id': 16,
            'name': 'Object Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        17: {
            'function_id': 17,
            'name': 'Ambient Temperature Reached',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        18: {
            'function_id': 18,
            'name': 'Object Temperature Reached',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
291: {
    'device_identifier': 291,
    'name': 'Temperature IR Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Ambient Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Set Ambient Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Ambient Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        4: {
            'function_id': 4,
            'name': 'Ambient Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        5: {
            'function_id': 5,
            'name': 'Get Object Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        6: {
            'function_id': 6,
            'name': 'Set Object Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Object Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        8: {
            'function_id': 8,
            'name': 'Object Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        9: {
            'function_id': 9,
            'name': 'Set Emissivity',
            'elements': [
                {
                    'name': 'Emissivity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Emissivity',
            'elements': [
                {
                    'name': 'Emissivity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2113: {
    'device_identifier': 2113,
    'name': 'Temperature Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        2: {
            'function_id': 2,
            'name': 'Set Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c h h',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c h h',
        },
        4: {
            'function_id': 4,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        5: {
            'function_id': 5,
            'name': 'Set Heater Configuration',
            'elements': [
                {
                    'name': 'Heater Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Heater Configuration',
            'elements': [
                {
                    'name': 'Heater Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
278: {
    'device_identifier': 278,
    'name': 'Thermal Imaging Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get High Contrast Image Low Level',
            'elements': [
                {
                    'name': 'Image Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Image Chunk Data',
                    'type': 'uint8',
                    'cardinality': '62',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H 62B',
        },
        2: {
            'function_id': 2,
            'name': 'Get Temperature Image Low Level',
            'elements': [
                {
                    'name': 'Image Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Image Chunk Data',
                    'type': 'uint16',
                    'cardinality': '31',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H 31H',
        },
        3: {
            'function_id': 3,
            'name': 'Get Statistics',
            'elements': [
                {
                    'name': 'Spotmeter Statistics',
                    'type': 'uint16',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Temperatures',
                    'type': 'uint16',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Resolution',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'FFC Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature Warning',
                    'type': 'bool',
                    'cardinality': '2',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4H 4H B B 2!',
        },
        4: {
            'function_id': 4,
            'name': 'Set Resolution',
            'elements': [
                {
                    'name': 'Resolution',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Resolution',
            'elements': [
                {
                    'name': 'Resolution',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        6: {
            'function_id': 6,
            'name': 'Set Spotmeter Config',
            'elements': [
                {
                    'name': 'Region Of Interest',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4B',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Spotmeter Config',
            'elements': [
                {
                    'name': 'Region Of Interest',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4B',
        },
        8: {
            'function_id': 8,
            'name': 'Set High Contrast Config',
            'elements': [
                {
                    'name': 'Region Of Interest',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'in'
                },
                {
                    'name': 'Dampening Factor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Clip Limit',
                    'type': 'uint16',
                    'cardinality': '2',
                    'direction': 'in'
                },
                {
                    'name': 'Empty Counts',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': '4B H 2H H',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get High Contrast Config',
            'elements': [
                {
                    'name': 'Region Of Interest',
                    'type': 'uint8',
                    'cardinality': '4',
                    'direction': 'out'
                },
                {
                    'name': 'Dampening Factor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Clip Limit',
                    'type': 'uint16',
                    'cardinality': '2',
                    'direction': 'out'
                },
                {
                    'name': 'Empty Counts',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '4B H 2H H',
        },
        10: {
            'function_id': 10,
            'name': 'Set Image Transfer Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Image Transfer Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        12: {
            'function_id': 12,
            'name': 'High Contrast Image Low Level',
            'elements': [
                {
                    'name': 'Image Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Image Chunk Data',
                    'type': 'uint8',
                    'cardinality': '62',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H 62B',
        },
        13: {
            'function_id': 13,
            'name': 'Temperature Image Low Level',
            'elements': [
                {
                    'name': 'Image Chunk Offset',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Image Chunk Data',
                    'type': 'uint16',
                    'cardinality': '31',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H 31H',
        },
        14: {
            'function_id': 14,
            'name': 'Set Flux Linear Parameters',
            'elements': [
                {
                    'name': 'Scene Emissivity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Temperature Background',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Tau Window',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Temperatur Window',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Tau Atmosphere',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Temperature Atmosphere',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Reflection Window',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Temperature Reflection',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H H H H H H H',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Flux Linear Parameters',
            'elements': [
                {
                    'name': 'Scene Emissivity',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature Background',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Tau Window',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperatur Window',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Tau Atmosphere',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature Atmosphere',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Reflection Window',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Temperature Reflection',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H H H H H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
266: {
    'device_identifier': 266,
    'name': 'Thermocouple Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Temperature Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Temperature Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        9: {
            'function_id': 9,
            'name': 'Temperature Reached',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        10: {
            'function_id': 10,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Averaging',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Thermocouple Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Averaging',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Thermocouple Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        12: {
            'function_id': 12,
            'name': 'Get Error State',
            'elements': [
                {
                    'name': 'Over Under',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Open Circuit',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! !',
        },
        13: {
            'function_id': 13,
            'name': 'Error State',
            'elements': [
                {
                    'name': 'Over Under',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Open Circuit',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! !',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2109: {
    'device_identifier': 2109,
    'name': 'Thermocouple Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Temperature Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        4: {
            'function_id': 4,
            'name': 'Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        5: {
            'function_id': 5,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Averaging',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Thermocouple Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Averaging',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Thermocouple Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Filter',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        7: {
            'function_id': 7,
            'name': 'Get Error State',
            'elements': [
                {
                    'name': 'Over Under',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Open Circuit',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! !',
        },
        8: {
            'function_id': 8,
            'name': 'Error State',
            'elements': [
                {
                    'name': 'Over Under',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Open Circuit',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '! !',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
239: {
    'device_identifier': 239,
    'name': 'Tilt Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Tilt State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        2: {
            'function_id': 2,
            'name': 'Enable Tilt State Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Disable Tilt State Callback',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Is Tilt State Callback Enabled',
            'elements': [
                {
                    'name': 'Enabled',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '!',
        },
        5: {
            'function_id': 5,
            'name': 'Tilt State',
            'elements': [
                {
                    'name': 'State',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
265: {
    'device_identifier': 265,
    'name': 'UV Light Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get UV Light',
            'elements': [
                {
                    'name': 'UV Light',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        2: {
            'function_id': 2,
            'name': 'Set UV Light Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get UV Light Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        4: {
            'function_id': 4,
            'name': 'Set UV Light Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c I I',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get UV Light Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c I I',
        },
        6: {
            'function_id': 6,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        8: {
            'function_id': 8,
            'name': 'UV Light',
            'elements': [
                {
                    'name': 'UV Light',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        9: {
            'function_id': 9,
            'name': 'UV Light Reached',
            'elements': [
                {
                    'name': 'UV Light',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2118: {
    'device_identifier': 2118,
    'name': 'UV Light Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get UVA',
            'elements': [
                {
                    'name': 'UVA',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set UVA Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get UVA Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        4: {
            'function_id': 4,
            'name': 'UVA',
            'elements': [
                {
                    'name': 'UVA',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        5: {
            'function_id': 5,
            'name': 'Get UVB',
            'elements': [
                {
                    'name': 'UVB',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        6: {
            'function_id': 6,
            'name': 'Set UVB Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get UVB Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        8: {
            'function_id': 8,
            'name': 'UVB',
            'elements': [
                {
                    'name': 'UVB',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        9: {
            'function_id': 9,
            'name': 'Get UVI',
            'elements': [
                {
                    'name': 'UVI',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        10: {
            'function_id': 10,
            'name': 'Set UVI Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get UVI Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        12: {
            'function_id': 12,
            'name': 'UVI',
            'elements': [
                {
                    'name': 'UVI',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        13: {
            'function_id': 13,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Integration Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
218: {
    'device_identifier': 218,
    'name': 'Voltage Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        2: {
            'function_id': 2,
            'name': 'Get Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        3: {
            'function_id': 3,
            'name': 'Set Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        5: {
            'function_id': 5,
            'name': 'Set Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        6: {
            'function_id': 6,
            'name': 'Get Analog Value Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        7: {
            'function_id': 7,
            'name': 'Set Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        9: {
            'function_id': 9,
            'name': 'Set Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c H H',
            'out_struct_format': '',
        },
        10: {
            'function_id': 10,
            'name': 'Get Analog Value Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c H H',
        },
        11: {
            'function_id': 11,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        13: {
            'function_id': 13,
            'name': 'Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        14: {
            'function_id': 14,
            'name': 'Analog Value',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        15: {
            'function_id': 15,
            'name': 'Voltage Reached',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        16: {
            'function_id': 16,
            'name': 'Analog Value Reached',
            'elements': [
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
227: {
    'device_identifier': 227,
    'name': 'Voltage/Current Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        3: {
            'function_id': 3,
            'name': 'Get Power',
            'elements': [
                {
                    'name': 'Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        4: {
            'function_id': 4,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Averaging',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Voltage Conversion Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current Conversion Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        5: {
            'function_id': 5,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Averaging',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Voltage Conversion Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Conversion Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        6: {
            'function_id': 6,
            'name': 'Set Calibration',
            'elements': [
                {
                    'name': 'Gain Multiplier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Gain Divisor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Calibration',
            'elements': [
                {
                    'name': 'Gain Multiplier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Gain Divisor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H',
        },
        8: {
            'function_id': 8,
            'name': 'Set Current Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        9: {
            'function_id': 9,
            'name': 'Get Current Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        10: {
            'function_id': 10,
            'name': 'Set Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Voltage Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        12: {
            'function_id': 12,
            'name': 'Set Power Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        13: {
            'function_id': 13,
            'name': 'Get Power Callback Period',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        14: {
            'function_id': 14,
            'name': 'Set Current Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        15: {
            'function_id': 15,
            'name': 'Get Current Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        16: {
            'function_id': 16,
            'name': 'Set Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        17: {
            'function_id': 17,
            'name': 'Get Voltage Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        18: {
            'function_id': 18,
            'name': 'Set Power Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'c i i',
            'out_struct_format': '',
        },
        19: {
            'function_id': 19,
            'name': 'Get Power Callback Threshold',
            'elements': [
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'c i i',
        },
        20: {
            'function_id': 20,
            'name': 'Set Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        21: {
            'function_id': 21,
            'name': 'Get Debounce Period',
            'elements': [
                {
                    'name': 'Debounce',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        22: {
            'function_id': 22,
            'name': 'Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        23: {
            'function_id': 23,
            'name': 'Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        24: {
            'function_id': 24,
            'name': 'Power',
            'elements': [
                {
                    'name': 'Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        25: {
            'function_id': 25,
            'name': 'Current Reached',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        26: {
            'function_id': 26,
            'name': 'Voltage Reached',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        27: {
            'function_id': 27,
            'name': 'Power Reached',
            'elements': [
                {
                    'name': 'Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
2105: {
    'device_identifier': 2105,
    'name': 'Voltage/Current Bricklet 2.0',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Get Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        2: {
            'function_id': 2,
            'name': 'Set Current Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        3: {
            'function_id': 3,
            'name': 'Get Current Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        4: {
            'function_id': 4,
            'name': 'Current',
            'elements': [
                {
                    'name': 'Current',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        5: {
            'function_id': 5,
            'name': 'Get Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        6: {
            'function_id': 6,
            'name': 'Set Voltage Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        7: {
            'function_id': 7,
            'name': 'Get Voltage Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        8: {
            'function_id': 8,
            'name': 'Voltage',
            'elements': [
                {
                    'name': 'Voltage',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        9: {
            'function_id': 9,
            'name': 'Get Power',
            'elements': [
                {
                    'name': 'Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        10: {
            'function_id': 10,
            'name': 'Set Power Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c i i',
            'out_struct_format': '',
        },
        11: {
            'function_id': 11,
            'name': 'Get Power Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c i i',
        },
        12: {
            'function_id': 12,
            'name': 'Power',
            'elements': [
                {
                    'name': 'Power',
                    'type': 'int32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'i',
        },
        13: {
            'function_id': 13,
            'name': 'Set Configuration',
            'elements': [
                {
                    'name': 'Averaging',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Voltage Conversion Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current Conversion Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B',
            'out_struct_format': '',
        },
        14: {
            'function_id': 14,
            'name': 'Get Configuration',
            'elements': [
                {
                    'name': 'Averaging',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Voltage Conversion Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Conversion Time',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B B B',
        },
        15: {
            'function_id': 15,
            'name': 'Set Calibration',
            'elements': [
                {
                    'name': 'Voltage Multiplier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Voltage Divisor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current Multiplier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Current Divisor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'H H H H',
            'out_struct_format': '',
        },
        16: {
            'function_id': 16,
            'name': 'Get Calibration',
            'elements': [
                {
                    'name': 'Voltage Multiplier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Voltage Divisor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Multiplier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Current Divisor',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'H H H H',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
},
279: {
    'device_identifier': 279,
    'name': 'XMC1400 Breakout Bricklet',
    'packets': {
        1: {
            'function_id': 1,
            'name': 'Set GPIO Config',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Input Hysteresis',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Output Level',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B B B B !',
            'out_struct_format': '',
        },
        2: {
            'function_id': 2,
            'name': 'Get GPIO Input',
            'elements': [
                {
                    'name': 'Port',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Pin',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B B',
            'out_struct_format': '!',
        },
        3: {
            'function_id': 3,
            'name': 'Set ADC Channel Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B !',
            'out_struct_format': '',
        },
        4: {
            'function_id': 4,
            'name': 'Get ADC Channel Config',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Enable',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '!',
        },
        5: {
            'function_id': 5,
            'name': 'Get ADC Channel Value',
            'elements': [
                {
                    'name': 'Channel',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'H',
        },
        6: {
            'function_id': 6,
            'name': 'Get ADC Values',
            'elements': [
                {
                    'name': 'Values',
                    'type': 'uint16',
                    'cardinality': '8',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8H',
        },
        7: {
            'function_id': 7,
            'name': 'Set ADC Values Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I !',
            'out_struct_format': '',
        },
        8: {
            'function_id': 8,
            'name': 'Get ADC Values Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I !',
        },
        9: {
            'function_id': 9,
            'name': 'ADC Values',
            'elements': [
                {
                    'name': 'Values',
                    'type': 'uint16',
                    'cardinality': '8',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8H',
        },
        10: {
            'function_id': 10,
            'name': 'Get Count',
            'elements': [
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        11: {
            'function_id': 11,
            'name': 'Set Count Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I ! c I I',
            'out_struct_format': '',
        },
        12: {
            'function_id': 12,
            'name': 'Get Count Callback Configuration',
            'elements': [
                {
                    'name': 'Period',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Value Has To Change',
                    'type': 'bool',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Option',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Min',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Max',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I ! c I I',
        },
        13: {
            'function_id': 13,
            'name': 'Count',
            'elements': [
                {
                    'name': 'Count',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        234: {
            'function_id': 234,
            'name': 'Get SPITFP Error Count',
            'elements': [
                {
                    'name': 'Error Count Ack Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Message Checksum',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Frame',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Error Count Overflow',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I I I I',
        },
        235: {
            'function_id': 235,
            'name': 'Set Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': 'B',
        },
        236: {
            'function_id': 236,
            'name': 'Get Bootloader Mode',
            'elements': [
                {
                    'name': 'Mode',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        237: {
            'function_id': 237,
            'name': 'Set Write Firmware Pointer',
            'elements': [
                {
                    'name': 'Pointer',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        238: {
            'function_id': 238,
            'name': 'Write Firmware',
            'elements': [
                {
                    'name': 'Data',
                    'type': 'uint8',
                    'cardinality': '64',
                    'direction': 'in'
                },
                {
                    'name': 'Status',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '64B',
            'out_struct_format': 'B',
        },
        239: {
            'function_id': 239,
            'name': 'Set Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'B',
            'out_struct_format': '',
        },
        240: {
            'function_id': 240,
            'name': 'Get Status LED Config',
            'elements': [
                {
                    'name': 'Config',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'B',
        },
        242: {
            'function_id': 242,
            'name': 'Get Chip Temperature',
            'elements': [
                {
                    'name': 'Temperature',
                    'type': 'int16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'h',
        },
        243: {
            'function_id': 243,
            'name': 'Reset',
            'elements': [
                
            ],
            'in_struct_format': '',
            'out_struct_format': '',
        },
        248: {
            'function_id': 248,
            'name': 'Write UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'in'
                }
            ],
            'in_struct_format': 'I',
            'out_struct_format': '',
        },
        249: {
            'function_id': 249,
            'name': 'Read UID',
            'elements': [
                {
                    'name': 'UID',
                    'type': 'uint32',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': 'I',
        },
        255: {
            'function_id': 255,
            'name': 'Get Identity',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H',
        },
        253: {
            'function_id': 253,
            'name': 'Enumerate',
            'elements': [
                {
                    'name': 'Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Connected Uid',
                    'type': 'string',
                    'cardinality': '8',
                    'direction': 'out'
                },
                {
                    'name': 'Position',
                    'type': 'char',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Hardware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Firmware Version',
                    'type': 'uint8',
                    'cardinality': '3',
                    'direction': 'out'
                },
                {
                    'name': 'Device Identifier',
                    'type': 'uint16',
                    'cardinality': '1',
                    'direction': 'out'
                },
                {
                    'name': 'Enumeration Type',
                    'type': 'uint8',
                    'cardinality': '1',
                    'direction': 'out'
                }
            ],
            'in_struct_format': '',
            'out_struct_format': '8s 8s c 3B 3B H B'
        }
    }
}
}

pearson = [1, 87, 49, 12, 176, 178, 102, 166, 121, 193, 6, 84, 249, 230, 44, 163,
	14, 197, 213, 181, 161, 85, 218, 80, 64, 239, 24, 226, 236, 142, 38, 200,
	110, 177, 104, 103, 141, 253, 255, 50, 77, 101, 81, 18, 45, 96, 31, 222,
	25, 107, 190, 70, 86, 237, 240, 34, 72, 242, 20, 214, 244, 227, 149, 235,
	97, 234, 57, 22, 60, 250, 82, 175, 208, 5, 127, 199, 111, 62, 135, 248,
	174, 169, 211, 58, 66, 154, 106, 195, 245, 171, 17, 187, 182, 179, 0, 243,
	132, 56, 148, 75, 128, 133, 158, 100, 130, 126, 91, 13, 153, 246, 216, 219,
	119, 68, 223, 78, 83, 88, 201, 99, 122, 11, 92, 32, 136, 114, 52, 10,
	138, 30, 48, 183, 156, 35, 61, 26, 143, 74, 251, 94, 129, 162, 63, 152,
	170, 7, 115, 167, 241, 206, 3, 150, 55, 59, 151, 220, 90, 53, 23, 131,
	125, 173, 15, 238, 79, 95, 89, 16, 105, 137, 225, 224, 217, 160, 37, 123,
	118, 73, 2, 157, 46, 116, 9, 145, 134, 228, 207, 212, 202, 215, 69, 229,
	27, 188, 67, 124, 168, 252, 42, 4, 29, 108, 21, 247, 19, 205, 39, 203,
	233, 40, 186, 147, 198, 192, 155, 33, 164, 191, 98, 204, 165, 180, 117, 76,
	140, 36, 210, 172, 41, 54, 159, 8, 185, 232, 113, 196, 231, 47, 146, 120,
	51, 65, 28, 144, 254, 221, 93, 189, 194, 139, 112, 43, 71, 109, 184, 209]

#checksum = 0
#packet = [0x0B, # Paketlänge
          #0x01, # Sequenznummer
          #0x98, 0x83, 0x00, 0x00, 0x08, 0x01, 0x18, 0x00 # Payload
          #]
#packet = [0x03, 0x10, 0x00]
#for byte in packet:
    #checksum = pearson[checksum ^ byte]
#print("{:x}".format(checksum))


def get_uid_from_data(data):
    return struct.unpack('<I', data[0:4])[0]

def get_length_from_data(data):
    return struct.unpack('<B', data[4:5])[0]

def get_function_id_from_data(data):
    return struct.unpack('<B', data[5:6])[0]

def get_sequence_number_from_data(data):
    return (struct.unpack('<B', data[6:7])[0] >> 4) & 0x0F

def get_response_expected_from_data(data):
    return ((struct.unpack('<B', data[6:7])[0]) & 0x08) != 0

def get_error_code_from_data(data):
    return (struct.unpack('<B', data[7:8])[0] >> 6) & 0x03

BASE58 = '123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ'

# internal
def base58encode(value):
    encoded = ''

    while value >= 58:
        div, mod = divmod(value, 58)
        encoded = BASE58[mod] + encoded
        value = div

    return BASE58[value] + encoded


class PacketBuffer():
    def __init__(self, is_master, dev_info, format):
        self.is_master = is_master
        self.data = []
        self.frame_start_times = []
        self.frame_end_times = []
        self.device_info = dev_info
        self.format = format

    def add_frame(self, frame):
        try:
            self.data.append(frame['data']['mosi' if self.is_master else 'miso'])
            self.frame_start_times.append(frame['start_time'])
            self.frame_end_times.append(frame['end_time'])
        except:
            pass

    def remove(self, n):
        self.data = self.data[n:]
        self.frame_start_times = self.frame_start_times[n:]
        self.frame_end_times = self.frame_end_times[n:]

    def find_packet(self, frame_type):
        while len(self.data) > 0:
            packet_len = self.data[0]
            if packet_len < 3 or packet_len > 83:
                self.remove(1)
                continue

            if packet_len > len(self.data):
                return None

            packet_checksum = self.data[-1]

            real_checksum = 0
            for byte in self.data[:-1]:
                real_checksum = pearson[real_checksum ^ byte]

            if real_checksum != packet_checksum:
                self.remove(1)
                continue

            seq_num = self.data[1] & 0x0F
            seq_num_acked = (self.data[1] & 0xF0) >> 4
            start_time = self.frame_start_times[0]
            end_time = self.frame_end_times[packet_len - 1]

            if packet_len == 3:
                self.remove(packet_len)
                return {
                    'type': 'Ack',
                    'start_time': start_time,
                    'end_time': end_time,
                    'data': {
                        'input_type': frame_type,
                        'length': packet_len,
                        'checksum': packet_checksum,
                        'seq_num': seq_num,
                        'seq_num_acked': seq_num_acked,
                    }
                }

            if packet_len < 11:
                payload = str(self.data[2:-1])
                self.remove(packet_len)
                return {
                    'type': 'Invalid',
                    'start_time': start_time,
                    'end_time': end_time,
                    'data': {
                        'input_type': frame_type,
                        'length': packet_len,
                        'checksum': packet_checksum,
                        'seq_num': seq_num,
                        'seq_num_acked': seq_num_acked,
                        'payload': payload
                    }
                }

            tfp_header = bytes(self.data[2:10])

            uid = base58encode(get_uid_from_data(tfp_header))
            tfp_length = get_length_from_data(tfp_header)
            fid = get_function_id_from_data(tfp_header)

            payload = 'unknown payload'

            try:
                packet = self.device_info['packets'][fid]

                fid = '{} ({})'.format(packet['name'], fid)
                struct_format = packet['in_struct_format'] if self.is_master else packet['out_struct_format']

                if len(struct_format) == 0:
                    payload = 'Empty'
                else:
                    payload = unpack_payload(bytes(self.data[10:-1]), struct_format)
                    if len(struct_format) == 1:
                        payload = [payload]
                    payload = [str(p) for p in payload]

                    direction = 'in' if self.is_master else 'out'
                    payload_names = [e['name'] for e in packet['elements'] if e['direction'] == direction]
                    payload = zip(payload_names, payload)
                    payload = '[' + ', '.join('{}: {}'.format(name, val) for name, val in payload) + ']'
            except:
                pass

            tfp_seq_num = get_sequence_number_from_data(tfp_header)
            error_code = get_error_code_from_data(tfp_header)
            response_expected = get_response_expected_from_data(tfp_header)

            self.remove(packet_len)
            return {
                'type': self.format,
                'start_time': start_time,
                'end_time': end_time,
                'data': {
                    'input_type': frame_type,
                    'length': packet_len,
                    'checksum': packet_checksum,
                    'seq_num': seq_num,
                    'seq_num_acked': seq_num_acked,
                    'uid': uid,
                    'tfp_length': tfp_length,
                    'fid': fid,
                    'tfp_seq_num': tfp_seq_num,
                    'error_code': error_code,
                    'response_expected': response_expected,
                    'payload': payload,
                }
            }

        return None


class Hla():

    def __init__(self):
        '''
        Initialize this HLA.

        If you have any initialization to do before any methods are called, you can do it here.
        '''
        self.packet_buffer = PacketBuffer(False, None, 'long')


    def get_capabilities(self):
        '''
        Return the settings that a user can set for this High Level Analyzer. The settings that a user selects will later be passed into `set_settings`.

        This method will be called first, before `set_settings` and `decode`
        '''

        devices = sorted(['{} ({})'.format(info['name'], info['device_identifier']) for info in device_infos.values()])


        return {
            'settings': {
                'Direction': {
                    'type': 'choices',
                    'choices': ('MOSI', 'MISO')
                },
                'Device': {
                    'type': 'choices',
                    'choices': tuple(devices)
                },
                'Output Format': {
                    'type': 'choices',
                    'choices': ('Everything', 'Payload', 'Headers')
                },
            }
        }

    def set_settings(self, settings):
        '''
        Handle the settings values chosen by the user, and return information about how to display the results that `decode` will return.

        This method will be called second, after `get_capbilities` and before `decode`.
        '''

        if 'Direction' in settings and 'Device' in settings and 'Output Format' in settings:
            dev_id = int(re.findall('[^\(]*\((\d*)\)', settings['Device'])[0])
            self.packet_buffer = PacketBuffer(settings['Direction'] == 'MOSI', device_infos[dev_id], settings['Output Format'])


        # Here you can specify how output frames will be formatted in the Logic 2 UI
        # If no format is given for a type, a default formatting will be used
        # You can include the values from your frame data (as returned by `decode`) by wrapping their name in double braces, as shown below.
        return {
            'result_types': {
                'Everything': {
                    'format': 'SPITFP [Len: {{data.length}}, SeqNum: {{data.seq_num}}, ACK: {{data.seq_num_acked}}] TFP [UID: {{data.uid}}, Len: {{data.tfp_length}}, FID: {{data.fid}}, SeqNum: {{data.tfp_seq_num}}, Error: {{data.error_code}}, RespExpected: {{data.response_expected}}, Payload: {{data.payload}}], Checksum: {{data.checksum}}'
                },
                'Payload': {
                    'format': 'TFP[FID: {{data.fid}}, Error: {{data.error_code}}, Payload: {{data.payload}}]'
                },
                'Headers': {
                    'format': 'SPITFP [Len: {{data.length}}, SeqNum: {{data.seq_num}}, ACK: {{data.seq_num_acked}}] TFP [UID: {{data.uid}}, Len: {{data.tfp_length}}, FID: {{data.fid}}, SeqNum: {{data.tfp_seq_num}}, Error: {{data.error_code}}, RespExpected: {{data.response_expected}}], Checksum: {{data.checksum}}'
                },
                'Ack': {
                    'format': 'SPITFP [Len: {{data.length}}, SeqNum: {{data.seq_num}}, ACK: {{data.seq_num_acked}}], Checksum: {{data.checksum}}'
                },
                'Invalid': {
                    'format': 'SPITFP [Len: {{data.length}}, SeqNum: {{data.seq_num}}, ACK: {{data.seq_num_acked}}], (Invalid!) SPITFP payload[{{data.payload}}] Checksum: {{data.checksum}}'
                }
            }
        }

    def decode(self, frame):
        '''
        Handle data frame from input analyzer.

        `frame` will always be of the form:

        {
            'type': 'FRAME_TYPE'
            'start_time': ...,
            'end_time': ...,
            'data': {
                ...
            }
        }

        The `type` and contents of the `data` field will depend on the input analyzer.
        '''
        self.packet_buffer.add_frame(frame)

        return self.packet_buffer.find_packet(frame['type'])

        #Return the data frame itself
        #return {
            #'type': 'mytype',  # This type matches up with the type returned from `set_settings`
            #'start_time': frame['start_time'],
            #'end_time': frame['end_time'],
            #'data': {
                #'input_type': frame['type'],
                #'mosi': frame['data']['mosi'],
                #'miso': frame['data']['miso']
            #}
        #}

